package com.example.model;

@io.swagger.annotations.ApiModel(value = "AbstractScaleQuestion")
@javax.xml.bind.annotation.XmlRootElement(name = "AbstractScaleQuestion")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class AbstractScaleQuestion implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private int min = 0;
	private int max = 0;
	private java.util.List<java.lang.String> labels = new java.util.ArrayList<java.lang.String>();
	private boolean requiresOtherTitle = false;
	
	/**
	 * minimum value for scale question and matrix question
	 */
	public AbstractScaleQuestion min(int min) {
		setMin(min);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "minimum value for scale question and matrix question")
	@com.fasterxml.jackson.annotation.JsonProperty("min")
	@javax.validation.constraints.NotNull
	public int getMin() {
		return this.min;
	}
	public void setMin(int min) {
		this.min = min;
	}
	
	/**
	 * maximum value for scale question and matrix question
	 */
	public AbstractScaleQuestion max(int max) {
		setMax(max);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "maximum value for scale question and matrix question")
	@com.fasterxml.jackson.annotation.JsonProperty("max")
	@javax.validation.constraints.NotNull
	public int getMax() {
		return this.max;
	}
	public void setMax(int max) {
		this.max = max;
	}
	
	/**
	 * array of labels of scale question and matrix question
	 */
	public AbstractScaleQuestion labels(java.util.List<java.lang.String> labels) {
		setLabels(labels);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "array of labels of scale question and matrix question")
	@com.fasterxml.jackson.annotation.JsonProperty("labels")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<java.lang.String> getLabels() {
		return this.labels;
	}
	public void setLabels(java.util.List<java.lang.String> labels) {
		this.labels = labels;
	}
	public void addLabel(java.lang.String label) {
		if (this.labels == null) {
			this.labels = new java.util.ArrayList<java.lang.String>();
		}
		this.labels.add(label);
	}
	
	/**
	 * true if matrix sub-question or scale question require user to set title
	 */
	public AbstractScaleQuestion requiresOtherTitle(boolean requiresOtherTitle) {
		setRequiresOtherTitle(requiresOtherTitle);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "true if matrix sub-question or scale question require user to set title")
	@com.fasterxml.jackson.annotation.JsonProperty("requiresOtherTitle")
	@javax.validation.constraints.NotNull
	public boolean isRequiresOtherTitle() {
		return this.requiresOtherTitle;
	}
	public void setRequiresOtherTitle(boolean requiresOtherTitle) {
		this.requiresOtherTitle = requiresOtherTitle;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		AbstractScaleQuestion abstractScaleQuestion = (AbstractScaleQuestion) o;
		return java.util.Objects.equals(this.min, abstractScaleQuestion.min) &&
				java.util.Objects.equals(this.max, abstractScaleQuestion.max) &&
				java.util.Objects.equals(this.labels, abstractScaleQuestion.labels) &&
				java.util.Objects.equals(this.requiresOtherTitle, abstractScaleQuestion.requiresOtherTitle);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.min, this.max, this.labels, this.requiresOtherTitle);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class AbstractScaleQuestion {\n");
		
		sb.append("    min: ").append(toIndentedString(this.min)).append("\n");
		sb.append("    max: ").append(toIndentedString(this.max)).append("\n");
		sb.append("    labels: ").append(toIndentedString(this.labels)).append("\n");
		sb.append("    requiresOtherTitle: ").append(toIndentedString(this.requiresOtherTitle)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
