package com.example.model;

@io.swagger.annotations.ApiModel(value = "AccountDetails")
@javax.xml.bind.annotation.XmlRootElement(name = "AccountDetails")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class AccountDetails extends com.example.model.AccountSummary implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.time.OffsetDateTime whenCreated = null;
	private java.lang.String riskContactEmail = null;
	private java.lang.Boolean disabled = null;
	private java.lang.Boolean removeCompletedParticipations = null;
	private java.lang.String privacyStatement = null;
	
	/**
	 */
	@java.lang.Override
	public AccountDetails id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public AccountDetails name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	/**
	 * An image
	 */
	@java.lang.Override
	public AccountDetails logo(com.example.model.Image logo) {
		setLogo(logo);
		return this;
	}
	
	/**
	 */
	public AccountDetails whenCreated(java.time.OffsetDateTime whenCreated) {
		setWhenCreated(whenCreated);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("whenCreated")
	@javax.validation.constraints.NotNull
	public java.time.OffsetDateTime getWhenCreated() {
		return this.whenCreated;
	}
	public void setWhenCreated(java.time.OffsetDateTime whenCreated) {
		this.whenCreated = whenCreated;
	}
	
	/**
	 * This property is only populated if the currently authenticated user is a super-admin.
	 */
	public AccountDetails riskContactEmail(java.lang.String riskContactEmail) {
		setRiskContactEmail(riskContactEmail);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "This property is only populated if the currently authenticated user is a super-admin.")
	@com.fasterxml.jackson.annotation.JsonProperty("riskContactEmail")
	@javax.validation.constraints.Email
	public java.lang.String getRiskContactEmail() {
		return this.riskContactEmail;
	}
	public void setRiskContactEmail(java.lang.String riskContactEmail) {
		this.riskContactEmail = riskContactEmail;
	}
	
	/**
	 * This property is only populated if the currently authenticated user is a super-admin.
	 */
	public AccountDetails disabled(java.lang.Boolean disabled) {
		setDisabled(disabled);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "This property is only populated if the currently authenticated user is a super-admin.")
	@com.fasterxml.jackson.annotation.JsonProperty("disabled")
	public java.lang.Boolean getDisabled() {
		return this.disabled;
	}
	public void setDisabled(java.lang.Boolean disabled) {
		this.disabled = disabled;
	}
	
	/**
	 * Whether account manager is allowed to remove completed participations before survey is closed.
	 */
	public AccountDetails removeCompletedParticipations(java.lang.Boolean removeCompletedParticipations) {
		setRemoveCompletedParticipations(removeCompletedParticipations);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Whether account manager is allowed to remove completed participations before survey is closed.")
	@com.fasterxml.jackson.annotation.JsonProperty("removeCompletedParticipations")
	public java.lang.Boolean getRemoveCompletedParticipations() {
		return this.removeCompletedParticipations;
	}
	public void setRemoveCompletedParticipations(java.lang.Boolean removeCompletedParticipations) {
		this.removeCompletedParticipations = removeCompletedParticipations;
	}
	
	/**
	 */
	public AccountDetails privacyStatement(java.lang.String privacyStatement) {
		setPrivacyStatement(privacyStatement);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("privacyStatement")
	public java.lang.String getPrivacyStatement() {
		return this.privacyStatement;
	}
	public void setPrivacyStatement(java.lang.String privacyStatement) {
		this.privacyStatement = privacyStatement;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		if (!super.equals(o)) {
			return false;
		}
		AccountDetails accountDetails = (AccountDetails) o;
		return java.util.Objects.equals(this.whenCreated, accountDetails.whenCreated) &&
				java.util.Objects.equals(this.riskContactEmail, accountDetails.riskContactEmail) &&
				java.util.Objects.equals(this.disabled, accountDetails.disabled) &&
				java.util.Objects.equals(this.removeCompletedParticipations, accountDetails.removeCompletedParticipations) &&
				java.util.Objects.equals(this.privacyStatement, accountDetails.privacyStatement);
	}
	
	@Override
	public int hashCode() {
		return 31 * super.hashCode() + java.util.Objects.hash(this.whenCreated, this.riskContactEmail, this.disabled, this.removeCompletedParticipations, this.privacyStatement);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class AccountDetails {\n");
		sb.append("    ").append(toIndentedString(super.toString())).append("\n");
		sb.append("    whenCreated: ").append(toIndentedString(this.whenCreated)).append("\n");
		sb.append("    riskContactEmail: ").append(toIndentedString(this.riskContactEmail)).append("\n");
		sb.append("    disabled: ").append(toIndentedString(this.disabled)).append("\n");
		sb.append("    removeCompletedParticipations: ").append(toIndentedString(this.removeCompletedParticipations)).append("\n");
		sb.append("    privacyStatement: ").append(toIndentedString(this.privacyStatement)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
