package com.example.model;

@io.swagger.annotations.ApiModel(value = "ArticleContent", discriminator="contentType")
@javax.xml.bind.annotation.XmlRootElement(name = "ArticleContent")
@com.fasterxml.jackson.annotation.JsonTypeInfo(use=com.fasterxml.jackson.annotation.JsonTypeInfo.Id.NAME, include=com.fasterxml.jackson.annotation.JsonTypeInfo.As.PROPERTY, property="contentType")
@com.fasterxml.jackson.annotation.JsonSubTypes({
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.ArticleContent.Text.class, name = "Text"),
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.ArticleContent.Html.class, name = "Html"),
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.ArticleContent.Image.class, name = "Image"),
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.ArticleContent.Links.class, name = "Links"),
})
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public interface ArticleContent extends java.io.Serializable {

	@io.swagger.annotations.ApiModel(value = "")
	public static class Text implements java.io.Serializable, com.example.model.ArticleContent {
	
		private static final long serialVersionUID = 1L;
		private java.lang.String title = null;
		private java.lang.String text = null;
		
		/**
		 */
		public Text title(java.lang.String title) {
			setTitle(title);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("title")
		public java.lang.String getTitle() {
			return this.title;
		}
		public void setTitle(java.lang.String title) {
			this.title = title;
		}
		
		/**
		 */
		public Text text(java.lang.String text) {
			setText(text);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("text")
		@javax.validation.constraints.NotNull
		public java.lang.String getText() {
			return this.text;
		}
		public void setText(java.lang.String text) {
			this.text = text;
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Text text = (Text) o;
			return java.util.Objects.equals(this.title, text.title) &&
					java.util.Objects.equals(this.text, text.text);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.title, this.text);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Text {\n");
			
			sb.append("    title: ").append(toIndentedString(this.title)).append("\n");
			sb.append("    text: ").append(toIndentedString(this.text)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	@io.swagger.annotations.ApiModel(value = "")
	public static class Html implements java.io.Serializable, com.example.model.ArticleContent {
	
		private static final long serialVersionUID = 1L;
		private java.lang.String title = null;
		private java.lang.String html = null;
		
		/**
		 */
		public Html title(java.lang.String title) {
			setTitle(title);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("title")
		public java.lang.String getTitle() {
			return this.title;
		}
		public void setTitle(java.lang.String title) {
			this.title = title;
		}
		
		/**
		 */
		public Html html(java.lang.String html) {
			setHtml(html);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("html")
		@javax.validation.constraints.NotNull
		public java.lang.String getHtml() {
			return this.html;
		}
		public void setHtml(java.lang.String html) {
			this.html = html;
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Html html = (Html) o;
			return java.util.Objects.equals(this.title, html.title) &&
					java.util.Objects.equals(this.html, html.html);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.title, this.html);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Html {\n");
			
			sb.append("    title: ").append(toIndentedString(this.title)).append("\n");
			sb.append("    html: ").append(toIndentedString(this.html)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	@io.swagger.annotations.ApiModel(value = "")
	public static class Image implements java.io.Serializable, com.example.model.ArticleContent {
	
		private static final long serialVersionUID = 1L;
		private java.net.URL url = null;
		private java.lang.String caption = null;
		
		/**
		 */
		public Image url(java.net.URL url) {
			setUrl(url);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("url")
		@javax.validation.constraints.NotNull
		public java.net.URL getUrl() {
			return this.url;
		}
		public void setUrl(java.net.URL url) {
			this.url = url;
		}
		
		/**
		 */
		public Image caption(java.lang.String caption) {
			setCaption(caption);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("caption")
		public java.lang.String getCaption() {
			return this.caption;
		}
		public void setCaption(java.lang.String caption) {
			this.caption = caption;
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Image image = (Image) o;
			return java.util.Objects.equals(this.url, image.url) &&
					java.util.Objects.equals(this.caption, image.caption);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.url, this.caption);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Image {\n");
			
			sb.append("    url: ").append(toIndentedString(this.url)).append("\n");
			sb.append("    caption: ").append(toIndentedString(this.caption)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	@io.swagger.annotations.ApiModel(value = "")
	public static class Links implements java.io.Serializable, com.example.model.ArticleContent {
	
		private static final long serialVersionUID = 1L;
		@io.swagger.annotations.ApiModel(value = "")
		public static class Link implements java.io.Serializable {
		
			private static final long serialVersionUID = 1L;
			private java.lang.String name = null;
			private java.net.URL url = null;
			private java.lang.String description = null;
			
			/**
			 */
			public Link name(java.lang.String name) {
				setName(name);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("name")
			@javax.validation.constraints.NotNull
			public java.lang.String getName() {
				return this.name;
			}
			public void setName(java.lang.String name) {
				this.name = name;
			}
			
			/**
			 */
			public Link url(java.net.URL url) {
				setUrl(url);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("url")
			@javax.validation.constraints.NotNull
			public java.net.URL getUrl() {
				return this.url;
			}
			public void setUrl(java.net.URL url) {
				this.url = url;
			}
			
			/**
			 */
			public Link description(java.lang.String description) {
				setDescription(description);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("description")
			public java.lang.String getDescription() {
				return this.description;
			}
			public void setDescription(java.lang.String description) {
				this.description = description;
			}
			
			@Override
			public boolean equals(java.lang.Object o) {
				if (this == o) {
					return true;
				}
				if (o == null || getClass() != o.getClass()) {
					return false;
				}
				Link link = (Link) o;
				return java.util.Objects.equals(this.name, link.name) &&
						java.util.Objects.equals(this.url, link.url) &&
						java.util.Objects.equals(this.description, link.description);
			}
			
			@Override
			public int hashCode() {
				return java.util.Objects.hash(this.name, this.url, this.description);
			}
			
			@Override
			public String toString() {
				StringBuilder sb = new StringBuilder();
				sb.append("class Link {\n");
				
				sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
				sb.append("    url: ").append(toIndentedString(this.url)).append("\n");
				sb.append("    description: ").append(toIndentedString(this.description)).append("\n");
				sb.append("}");
				return sb.toString();
			}
			
			/**
			 * Convert the given object to string with each line indented by 4 spaces
			 * (except the first line).
			 */
			private String toIndentedString(java.lang.Object o) {
				if (o == null) {
					return "null";
				}
				return o.toString().replace("\n", "\n    ");
			}
			
		}
		
		private java.lang.String title = null;
		private java.util.List<com.example.model.ArticleContent.Links.Link> links = null;
		
		/**
		 */
		public Links title(java.lang.String title) {
			setTitle(title);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("title")
		public java.lang.String getTitle() {
			return this.title;
		}
		public void setTitle(java.lang.String title) {
			this.title = title;
		}
		
		/**
		 */
		public Links links(java.util.List<com.example.model.ArticleContent.Links.Link> links) {
			setLinks(links);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("links")
		@javax.validation.Valid
		public java.util.List<com.example.model.ArticleContent.Links.Link> getLinks() {
			return this.links;
		}
		public void setLinks(java.util.List<com.example.model.ArticleContent.Links.Link> links) {
			this.links = links;
		}
		public void addLink(com.example.model.ArticleContent.Links.Link link) {
			if (this.links == null) {
				this.links = new java.util.ArrayList<com.example.model.ArticleContent.Links.Link>();
			}
			this.links.add(link);
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Links links = (Links) o;
			return java.util.Objects.equals(this.title, links.title) &&
					java.util.Objects.equals(this.links, links.links);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.title, this.links);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Links {\n");
			
			sb.append("    title: ").append(toIndentedString(this.title)).append("\n");
			sb.append("    links: ").append(toIndentedString(this.links)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
}
