package com.example.model;

@io.swagger.annotations.ApiModel(value = "")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class CreateSurveyRequest implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.UUID templateId = null;
	private java.lang.String name = null;
	private com.example.model.Scheduling scheduling = null;
	
	/**
	 */
	public CreateSurveyRequest templateId(java.util.UUID templateId) {
		setTemplateId(templateId);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("templateId")
	@javax.validation.constraints.NotNull
	public java.util.UUID getTemplateId() {
		return this.templateId;
	}
	public void setTemplateId(java.util.UUID templateId) {
		this.templateId = templateId;
	}
	
	/**
	 */
	public CreateSurveyRequest name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("name")
	@javax.validation.constraints.NotBlank
	public java.lang.String getName() {
		return this.name;
	}
	public void setName(java.lang.String name) {
		this.name = name;
	}
	
	/**
	 */
	public CreateSurveyRequest scheduling(com.example.model.Scheduling scheduling) {
		setScheduling(scheduling);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("scheduling")
	@javax.validation.Valid
	public com.example.model.Scheduling getScheduling() {
		return this.scheduling;
	}
	public void setScheduling(com.example.model.Scheduling scheduling) {
		this.scheduling = scheduling;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		CreateSurveyRequest createSurveyRequest = (CreateSurveyRequest) o;
		return java.util.Objects.equals(this.templateId, createSurveyRequest.templateId) &&
				java.util.Objects.equals(this.name, createSurveyRequest.name) &&
				java.util.Objects.equals(this.scheduling, createSurveyRequest.scheduling);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.templateId, this.name, this.scheduling);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class CreateSurveyRequest {\n");
		
		sb.append("    templateId: ").append(toIndentedString(this.templateId)).append("\n");
		sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
		sb.append("    scheduling: ").append(toIndentedString(this.scheduling)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
