package com.example.model;

@io.swagger.annotations.ApiModel(value = "PersonSummary")
@javax.xml.bind.annotation.XmlRootElement(name = "PersonSummary")
@com.fasterxml.jackson.annotation.JsonSubTypes({
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.PersonDetails.class, name = "PersonDetails"),
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.UserDetails.class, name = "UserDetails"),
})
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class PersonSummary implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.UUID id = null;
	private java.lang.String name = null;
	private java.lang.String givenName = null;
	private java.lang.String familyName = null;
	private java.lang.String emailAddress = null;
	
	/**
	 */
	public PersonSummary id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("id")
	@javax.validation.constraints.NotNull
	public java.util.UUID getId() {
		return this.id;
	}
	public void setId(java.util.UUID id) {
		this.id = id;
	}
	
	/**
	 */
	public PersonSummary name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("name")
	@javax.validation.constraints.NotNull
	public java.lang.String getName() {
		return this.name;
	}
	public void setName(java.lang.String name) {
		this.name = name;
	}
	
	/**
	 */
	public PersonSummary givenName(java.lang.String givenName) {
		setGivenName(givenName);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("givenName")
	@javax.validation.constraints.NotNull
	public java.lang.String getGivenName() {
		return this.givenName;
	}
	public void setGivenName(java.lang.String givenName) {
		this.givenName = givenName;
	}
	
	/**
	 */
	public PersonSummary familyName(java.lang.String familyName) {
		setFamilyName(familyName);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("familyName")
	@javax.validation.constraints.NotNull
	public java.lang.String getFamilyName() {
		return this.familyName;
	}
	public void setFamilyName(java.lang.String familyName) {
		this.familyName = familyName;
	}
	
	/**
	 */
	public PersonSummary emailAddress(java.lang.String emailAddress) {
		setEmailAddress(emailAddress);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("emailAddress")
	@javax.validation.constraints.NotNull
	public java.lang.String getEmailAddress() {
		return this.emailAddress;
	}
	public void setEmailAddress(java.lang.String emailAddress) {
		this.emailAddress = emailAddress;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		PersonSummary personSummary = (PersonSummary) o;
		return java.util.Objects.equals(this.id, personSummary.id) &&
				java.util.Objects.equals(this.name, personSummary.name) &&
				java.util.Objects.equals(this.givenName, personSummary.givenName) &&
				java.util.Objects.equals(this.familyName, personSummary.familyName) &&
				java.util.Objects.equals(this.emailAddress, personSummary.emailAddress);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.id, this.name, this.givenName, this.familyName, this.emailAddress);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class PersonSummary {\n");
		
		sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
		sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
		sb.append("    givenName: ").append(toIndentedString(this.givenName)).append("\n");
		sb.append("    familyName: ").append(toIndentedString(this.familyName)).append("\n");
		sb.append("    emailAddress: ").append(toIndentedString(this.emailAddress)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
