package com.example.model;

@io.swagger.annotations.ApiModel(value = "")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class PostResetPasswordRequest implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.lang.String token = null;
	private java.lang.String newPassword = null;
	
	/**
	 * The forgotten password token that was sent to the user’s email address.
	 */
	public PostResetPasswordRequest token(java.lang.String token) {
		setToken(token);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "The forgotten password token that was sent to the user’s email address.")
	@com.fasterxml.jackson.annotation.JsonProperty("token")
	@javax.validation.constraints.NotNull
	public java.lang.String getToken() {
		return this.token;
	}
	public void setToken(java.lang.String token) {
		this.token = token;
	}
	
	/**
	 * The password to change to.
	 */
	public PostResetPasswordRequest newPassword(java.lang.String newPassword) {
		setNewPassword(newPassword);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "The password to change to.")
	@com.fasterxml.jackson.annotation.JsonProperty("newPassword")
	@javax.validation.constraints.NotNull
	public java.lang.String getNewPassword() {
		return this.newPassword;
	}
	public void setNewPassword(java.lang.String newPassword) {
		this.newPassword = newPassword;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		PostResetPasswordRequest postResetPasswordRequest = (PostResetPasswordRequest) o;
		return java.util.Objects.equals(this.token, postResetPasswordRequest.token) &&
				java.util.Objects.equals(this.newPassword, postResetPasswordRequest.newPassword);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.token, this.newPassword);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class PostResetPasswordRequest {\n");
		
		sb.append("    token: ").append(toIndentedString(this.token)).append("\n");
		sb.append("    newPassword: ").append(toIndentedString(this.newPassword)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
