package com.example.model;

@io.swagger.annotations.ApiModel(value = "")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class StartTotp200Response implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.lang.String qrcode = null;
	private java.lang.String token = null;
	
	/**
	 * A data URI containing a QR code containing the TOTP configuration
	 */
	public StartTotp200Response qrcode(java.lang.String qrcode) {
		setQrcode(qrcode);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "A data URI containing a QR code containing the TOTP configuration")
	@com.fasterxml.jackson.annotation.JsonProperty("qrcode")
	@javax.validation.constraints.NotNull
	public java.lang.String getQrcode() {
		return this.qrcode;
	}
	public void setQrcode(java.lang.String qrcode) {
		this.qrcode = qrcode;
	}
	
	/**
	 * A token to be passed back when confirming the TOTP.
	 */
	public StartTotp200Response token(java.lang.String token) {
		setToken(token);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "A token to be passed back when confirming the TOTP.")
	@com.fasterxml.jackson.annotation.JsonProperty("token")
	public java.lang.String getToken() {
		return this.token;
	}
	public void setToken(java.lang.String token) {
		this.token = token;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		StartTotp200Response startTotp200Response = (StartTotp200Response) o;
		return java.util.Objects.equals(this.qrcode, startTotp200Response.qrcode) &&
				java.util.Objects.equals(this.token, startTotp200Response.token);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.qrcode, this.token);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class StartTotp200Response {\n");
		
		sb.append("    qrcode: ").append(toIndentedString(this.qrcode)).append("\n");
		sb.append("    token: ").append(toIndentedString(this.token)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
