package com.example.model;

/**
 * The details with which to update a survey
 */
@io.swagger.annotations.ApiModel(value = "SurveyDetailsUpdate", description = "The details with which to update a survey")
@javax.xml.bind.annotation.XmlRootElement(name = "SurveyDetailsUpdate")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class SurveyDetailsUpdate implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@io.swagger.annotations.ApiModel(value = "")
	public static class TestEmails implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		private boolean invitation = false;
		private boolean thanks = false;
		private boolean riskThanks = false;
		
		/**
		 */
		public TestEmails invitation(boolean invitation) {
			setInvitation(invitation);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("invitation")
		@javax.validation.constraints.NotNull
		public boolean isInvitation() {
			return this.invitation;
		}
		public void setInvitation(boolean invitation) {
			this.invitation = invitation;
		}
		
		/**
		 */
		public TestEmails thanks(boolean thanks) {
			setThanks(thanks);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("thanks")
		@javax.validation.constraints.NotNull
		public boolean isThanks() {
			return this.thanks;
		}
		public void setThanks(boolean thanks) {
			this.thanks = thanks;
		}
		
		/**
		 */
		public TestEmails riskThanks(boolean riskThanks) {
			setRiskThanks(riskThanks);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("riskThanks")
		@javax.validation.constraints.NotNull
		public boolean isRiskThanks() {
			return this.riskThanks;
		}
		public void setRiskThanks(boolean riskThanks) {
			this.riskThanks = riskThanks;
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			TestEmails testEmails = (TestEmails) o;
			return java.util.Objects.equals(this.invitation, testEmails.invitation) &&
					java.util.Objects.equals(this.thanks, testEmails.thanks) &&
					java.util.Objects.equals(this.riskThanks, testEmails.riskThanks);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.invitation, this.thanks, this.riskThanks);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class TestEmails {\n");
			
			sb.append("    invitation: ").append(toIndentedString(this.invitation)).append("\n");
			sb.append("    thanks: ").append(toIndentedString(this.thanks)).append("\n");
			sb.append("    riskThanks: ").append(toIndentedString(this.riskThanks)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	private java.lang.String name = null;
	private boolean __patchedName = false;
	private java.util.UUID template = null;
	private boolean __patchedTemplate = false;
	private com.example.model.Scheduling scheduling = null;
	private boolean __patchedScheduling = false;
	private java.lang.Boolean archived = null;
	private boolean __patchedArchived = false;
	private java.lang.String contactName = null;
	private boolean __patchedContactName = false;
	private java.lang.String contactEmail = null;
	private boolean __patchedContactEmail = false;
	private java.lang.String riskContactEmail = null;
	private boolean __patchedRiskContactEmail = false;
	private java.lang.String invitationMessage = null;
	private boolean __patchedInvitationMessage = false;
	private java.lang.String welcome = null;
	private boolean __patchedWelcome = false;
	private java.lang.String thanksMessage = null;
	private boolean __patchedThanksMessage = false;
	private java.lang.String riskThanksMessage = null;
	private boolean __patchedRiskThanksMessage = false;
	private java.lang.String privacyStatement = null;
	private boolean __patchedPrivacyStatement = false;
	private com.example.model.SurveyDetailsUpdate.TestEmails testEmails = null;
	private boolean __patchedTestEmails = false;
	
	/**
	 */
	public SurveyDetailsUpdate name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("name")
	public java.lang.String getName() {
		return this.name;
	}
	public void setName(java.lang.String name) {
		this.name = name;
		this.__patchedName = true;
	}
	public boolean patchedName() {
		return this.__patchedName;
	}
	
	/**
	 */
	public SurveyDetailsUpdate template(java.util.UUID template) {
		setTemplate(template);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("template")
	public java.util.UUID getTemplate() {
		return this.template;
	}
	public void setTemplate(java.util.UUID template) {
		this.template = template;
		this.__patchedTemplate = true;
	}
	public boolean patchedTemplate() {
		return this.__patchedTemplate;
	}
	
	/**
	 */
	public SurveyDetailsUpdate scheduling(com.example.model.Scheduling scheduling) {
		setScheduling(scheduling);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("scheduling")
	@javax.validation.Valid
	public com.example.model.Scheduling getScheduling() {
		return this.scheduling;
	}
	public void setScheduling(com.example.model.Scheduling scheduling) {
		this.scheduling = scheduling;
		this.__patchedScheduling = true;
	}
	public boolean patchedScheduling() {
		return this.__patchedScheduling;
	}
	
	/**
	 * Set whether the survey is archived or not.
	 */
	public SurveyDetailsUpdate archived(java.lang.Boolean archived) {
		setArchived(archived);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Set whether the survey is archived or not.")
	@com.fasterxml.jackson.annotation.JsonProperty("archived")
	public java.lang.Boolean getArchived() {
		return this.archived;
	}
	public void setArchived(java.lang.Boolean archived) {
		this.archived = archived;
		this.__patchedArchived = true;
	}
	public boolean patchedArchived() {
		return this.__patchedArchived;
	}
	
	/**
	 */
	public SurveyDetailsUpdate contactName(java.lang.String contactName) {
		setContactName(contactName);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("contactName")
	public java.lang.String getContactName() {
		return this.contactName;
	}
	public void setContactName(java.lang.String contactName) {
		this.contactName = contactName;
		this.__patchedContactName = true;
	}
	public boolean patchedContactName() {
		return this.__patchedContactName;
	}
	
	/**
	 */
	public SurveyDetailsUpdate contactEmail(java.lang.String contactEmail) {
		setContactEmail(contactEmail);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("contactEmail")
	@javax.validation.constraints.Email
	public java.lang.String getContactEmail() {
		return this.contactEmail;
	}
	public void setContactEmail(java.lang.String contactEmail) {
		this.contactEmail = contactEmail;
		this.__patchedContactEmail = true;
	}
	public boolean patchedContactEmail() {
		return this.__patchedContactEmail;
	}
	
	/**
	 */
	public SurveyDetailsUpdate riskContactEmail(java.lang.String riskContactEmail) {
		setRiskContactEmail(riskContactEmail);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("riskContactEmail")
	@javax.validation.constraints.Email
	public java.lang.String getRiskContactEmail() {
		return this.riskContactEmail;
	}
	public void setRiskContactEmail(java.lang.String riskContactEmail) {
		this.riskContactEmail = riskContactEmail;
		this.__patchedRiskContactEmail = true;
	}
	public boolean patchedRiskContactEmail() {
		return this.__patchedRiskContactEmail;
	}
	
	/**
	 */
	public SurveyDetailsUpdate invitationMessage(java.lang.String invitationMessage) {
		setInvitationMessage(invitationMessage);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("invitationMessage")
	public java.lang.String getInvitationMessage() {
		return this.invitationMessage;
	}
	public void setInvitationMessage(java.lang.String invitationMessage) {
		this.invitationMessage = invitationMessage;
		this.__patchedInvitationMessage = true;
	}
	public boolean patchedInvitationMessage() {
		return this.__patchedInvitationMessage;
	}
	
	/**
	 */
	public SurveyDetailsUpdate welcome(java.lang.String welcome) {
		setWelcome(welcome);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("welcome")
	public java.lang.String getWelcome() {
		return this.welcome;
	}
	public void setWelcome(java.lang.String welcome) {
		this.welcome = welcome;
		this.__patchedWelcome = true;
	}
	public boolean patchedWelcome() {
		return this.__patchedWelcome;
	}
	
	/**
	 */
	public SurveyDetailsUpdate thanksMessage(java.lang.String thanksMessage) {
		setThanksMessage(thanksMessage);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("thanksMessage")
	public java.lang.String getThanksMessage() {
		return this.thanksMessage;
	}
	public void setThanksMessage(java.lang.String thanksMessage) {
		this.thanksMessage = thanksMessage;
		this.__patchedThanksMessage = true;
	}
	public boolean patchedThanksMessage() {
		return this.__patchedThanksMessage;
	}
	
	/**
	 */
	public SurveyDetailsUpdate riskThanksMessage(java.lang.String riskThanksMessage) {
		setRiskThanksMessage(riskThanksMessage);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("riskThanksMessage")
	public java.lang.String getRiskThanksMessage() {
		return this.riskThanksMessage;
	}
	public void setRiskThanksMessage(java.lang.String riskThanksMessage) {
		this.riskThanksMessage = riskThanksMessage;
		this.__patchedRiskThanksMessage = true;
	}
	public boolean patchedRiskThanksMessage() {
		return this.__patchedRiskThanksMessage;
	}
	
	/**
	 */
	public SurveyDetailsUpdate privacyStatement(java.lang.String privacyStatement) {
		setPrivacyStatement(privacyStatement);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("privacyStatement")
	public java.lang.String getPrivacyStatement() {
		return this.privacyStatement;
	}
	public void setPrivacyStatement(java.lang.String privacyStatement) {
		this.privacyStatement = privacyStatement;
		this.__patchedPrivacyStatement = true;
	}
	public boolean patchedPrivacyStatement() {
		return this.__patchedPrivacyStatement;
	}
	
	/**
	 */
	public SurveyDetailsUpdate testEmails(com.example.model.SurveyDetailsUpdate.TestEmails testEmails) {
		setTestEmails(testEmails);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("testEmails")
	@javax.validation.Valid
	public com.example.model.SurveyDetailsUpdate.TestEmails getTestEmails() {
		return this.testEmails;
	}
	public void setTestEmails(com.example.model.SurveyDetailsUpdate.TestEmails testEmails) {
		this.testEmails = testEmails;
		this.__patchedTestEmails = true;
	}
	public boolean patchedTestEmails() {
		return this.__patchedTestEmails;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		SurveyDetailsUpdate surveyDetailsUpdate = (SurveyDetailsUpdate) o;
		return java.util.Objects.equals(this.name, surveyDetailsUpdate.name) &&
				java.util.Objects.equals(this.template, surveyDetailsUpdate.template) &&
				java.util.Objects.equals(this.scheduling, surveyDetailsUpdate.scheduling) &&
				java.util.Objects.equals(this.archived, surveyDetailsUpdate.archived) &&
				java.util.Objects.equals(this.contactName, surveyDetailsUpdate.contactName) &&
				java.util.Objects.equals(this.contactEmail, surveyDetailsUpdate.contactEmail) &&
				java.util.Objects.equals(this.riskContactEmail, surveyDetailsUpdate.riskContactEmail) &&
				java.util.Objects.equals(this.invitationMessage, surveyDetailsUpdate.invitationMessage) &&
				java.util.Objects.equals(this.welcome, surveyDetailsUpdate.welcome) &&
				java.util.Objects.equals(this.thanksMessage, surveyDetailsUpdate.thanksMessage) &&
				java.util.Objects.equals(this.riskThanksMessage, surveyDetailsUpdate.riskThanksMessage) &&
				java.util.Objects.equals(this.privacyStatement, surveyDetailsUpdate.privacyStatement) &&
				java.util.Objects.equals(this.testEmails, surveyDetailsUpdate.testEmails);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.name, this.template, this.scheduling, this.archived, this.contactName, this.contactEmail, this.riskContactEmail, this.invitationMessage, this.welcome, this.thanksMessage, this.riskThanksMessage, this.privacyStatement, this.testEmails);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class SurveyDetailsUpdate {\n");
		
		sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
		sb.append("    template: ").append(toIndentedString(this.template)).append("\n");
		sb.append("    scheduling: ").append(toIndentedString(this.scheduling)).append("\n");
		sb.append("    archived: ").append(toIndentedString(this.archived)).append("\n");
		sb.append("    contactName: ").append(toIndentedString(this.contactName)).append("\n");
		sb.append("    contactEmail: ").append(toIndentedString(this.contactEmail)).append("\n");
		sb.append("    riskContactEmail: ").append(toIndentedString(this.riskContactEmail)).append("\n");
		sb.append("    invitationMessage: ").append(toIndentedString(this.invitationMessage)).append("\n");
		sb.append("    welcome: ").append(toIndentedString(this.welcome)).append("\n");
		sb.append("    thanksMessage: ").append(toIndentedString(this.thanksMessage)).append("\n");
		sb.append("    riskThanksMessage: ").append(toIndentedString(this.riskThanksMessage)).append("\n");
		sb.append("    privacyStatement: ").append(toIndentedString(this.privacyStatement)).append("\n");
		sb.append("    testEmails: ").append(toIndentedString(this.testEmails)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
