package com.example.model;

@io.swagger.annotations.ApiModel(value = "SurveyParticipationsResponse")
@javax.xml.bind.annotation.XmlRootElement(name = "SurveyParticipationsResponse")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class SurveyParticipationsResponse implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.lang.String nextCursor = null;
	private java.util.List<com.example.model.Participation> participations = new java.util.ArrayList<com.example.model.Participation>();
	
	/**
	 */
	public SurveyParticipationsResponse nextCursor(java.lang.String nextCursor) {
		setNextCursor(nextCursor);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("nextCursor")
	public java.lang.String getNextCursor() {
		return this.nextCursor;
	}
	public void setNextCursor(java.lang.String nextCursor) {
		this.nextCursor = nextCursor;
	}
	
	/**
	 */
	public SurveyParticipationsResponse participations(java.util.List<com.example.model.Participation> participations) {
		setParticipations(participations);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("participations")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<com.example.model.Participation> getParticipations() {
		return this.participations;
	}
	public void setParticipations(java.util.List<com.example.model.Participation> participations) {
		this.participations = participations;
	}
	public void addParticipation(com.example.model.Participation participation) {
		if (this.participations == null) {
			this.participations = new java.util.ArrayList<com.example.model.Participation>();
		}
		this.participations.add(participation);
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		SurveyParticipationsResponse surveyParticipationsResponse = (SurveyParticipationsResponse) o;
		return java.util.Objects.equals(this.nextCursor, surveyParticipationsResponse.nextCursor) &&
				java.util.Objects.equals(this.participations, surveyParticipationsResponse.participations);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.nextCursor, this.participations);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class SurveyParticipationsResponse {\n");
		
		sb.append("    nextCursor: ").append(toIndentedString(this.nextCursor)).append("\n");
		sb.append("    participations: ").append(toIndentedString(this.participations)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
