package com.example.model;

@io.swagger.annotations.ApiModel(value = "SurveyReportAspectsArea")
@javax.xml.bind.annotation.XmlRootElement(name = "SurveyReportAspectsArea")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class SurveyReportAspectsArea extends com.example.model.SurveyReportArea implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@io.swagger.annotations.ApiModel(value = "")
	public static class Series implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		@io.swagger.annotations.ApiModel(value = "")
		public static class Aspect implements java.io.Serializable {
		
			private static final long serialVersionUID = 1L;
			private java.lang.String name = null;
			private java.lang.String longName = null;
			private java.lang.String code = null;
			private java.lang.String icon = null;
			private java.math.BigDecimal score = null;
			private java.math.BigDecimal minRatio = new java.math.BigDecimal("0");
			private java.math.BigDecimal midRatio = new java.math.BigDecimal("0");
			private java.math.BigDecimal maxRatio = new java.math.BigDecimal("0");
			private java.lang.String group = null;
			
			/**
			 */
			public Aspect name(java.lang.String name) {
				setName(name);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("name")
			@javax.validation.constraints.NotNull
			public java.lang.String getName() {
				return this.name;
			}
			public void setName(java.lang.String name) {
				this.name = name;
			}
			
			/**
			 * A longer version of the name, to be used where possible.
			 */
			public Aspect longName(java.lang.String longName) {
				setLongName(longName);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "A longer version of the name, to be used where possible.")
			@com.fasterxml.jackson.annotation.JsonProperty("longName")
			@javax.validation.constraints.NotNull
			public java.lang.String getLongName() {
				return this.longName;
			}
			public void setLongName(java.lang.String longName) {
				this.longName = longName;
			}
			
			/**
			 */
			public Aspect code(java.lang.String code) {
				setCode(code);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("code")
			public java.lang.String getCode() {
				return this.code;
			}
			public void setCode(java.lang.String code) {
				this.code = code;
			}
			
			/**
			 * The name of the icon to use for this aspect, if any.
			 */
			public Aspect icon(java.lang.String icon) {
				setIcon(icon);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(value = "The name of the icon to use for this aspect, if any.")
			@com.fasterxml.jackson.annotation.JsonProperty("icon")
			public java.lang.String getIcon() {
				return this.icon;
			}
			public void setIcon(java.lang.String icon) {
				this.icon = icon;
			}
			
			/**
			 * Score between 0.0 and 1.0
			 */
			public Aspect score(java.math.BigDecimal score) {
				setScore(score);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(value = "Score between 0.0 and 1.0")
			@com.fasterxml.jackson.annotation.JsonProperty("score")
			public java.math.BigDecimal getScore() {
				return this.score;
			}
			public void setScore(java.math.BigDecimal score) {
				this.score = score;
			}
			
			/**
			 * The ratio of all respondents who are in the min group.
			 */
			public Aspect minRatio(java.math.BigDecimal minRatio) {
				setMinRatio(minRatio);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "The ratio of all respondents who are in the min group.")
			@com.fasterxml.jackson.annotation.JsonProperty("minRatio")
			@javax.validation.constraints.NotNull
			public java.math.BigDecimal getMinRatio() {
				return this.minRatio;
			}
			public void setMinRatio(java.math.BigDecimal minRatio) {
				this.minRatio = minRatio;
			}
			
			/**
			 */
			public Aspect midRatio(java.math.BigDecimal midRatio) {
				setMidRatio(midRatio);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("midRatio")
			@javax.validation.constraints.NotNull
			public java.math.BigDecimal getMidRatio() {
				return this.midRatio;
			}
			public void setMidRatio(java.math.BigDecimal midRatio) {
				this.midRatio = midRatio;
			}
			
			/**
			 */
			public Aspect maxRatio(java.math.BigDecimal maxRatio) {
				setMaxRatio(maxRatio);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("maxRatio")
			@javax.validation.constraints.NotNull
			public java.math.BigDecimal getMaxRatio() {
				return this.maxRatio;
			}
			public void setMaxRatio(java.math.BigDecimal maxRatio) {
				this.maxRatio = maxRatio;
			}
			
			/**
			 * The code of the group that this aspect is in, if any.
			 */
			public Aspect group(java.lang.String group) {
				setGroup(group);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(value = "The code of the group that this aspect is in, if any.")
			@com.fasterxml.jackson.annotation.JsonProperty("group")
			public java.lang.String getGroup() {
				return this.group;
			}
			public void setGroup(java.lang.String group) {
				this.group = group;
			}
			
			@Override
			public boolean equals(java.lang.Object o) {
				if (this == o) {
					return true;
				}
				if (o == null || getClass() != o.getClass()) {
					return false;
				}
				Aspect aspect = (Aspect) o;
				return java.util.Objects.equals(this.name, aspect.name) &&
						java.util.Objects.equals(this.longName, aspect.longName) &&
						java.util.Objects.equals(this.code, aspect.code) &&
						java.util.Objects.equals(this.icon, aspect.icon) &&
						java.util.Objects.equals(this.score, aspect.score) &&
						java.util.Objects.equals(this.minRatio, aspect.minRatio) &&
						java.util.Objects.equals(this.midRatio, aspect.midRatio) &&
						java.util.Objects.equals(this.maxRatio, aspect.maxRatio) &&
						java.util.Objects.equals(this.group, aspect.group);
			}
			
			@Override
			public int hashCode() {
				return java.util.Objects.hash(this.name, this.longName, this.code, this.icon, this.score, this.minRatio, this.midRatio, this.maxRatio, this.group);
			}
			
			@Override
			public String toString() {
				StringBuilder sb = new StringBuilder();
				sb.append("class Aspect {\n");
				
				sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
				sb.append("    longName: ").append(toIndentedString(this.longName)).append("\n");
				sb.append("    code: ").append(toIndentedString(this.code)).append("\n");
				sb.append("    icon: ").append(toIndentedString(this.icon)).append("\n");
				sb.append("    score: ").append(toIndentedString(this.score)).append("\n");
				sb.append("    minRatio: ").append(toIndentedString(this.minRatio)).append("\n");
				sb.append("    midRatio: ").append(toIndentedString(this.midRatio)).append("\n");
				sb.append("    maxRatio: ").append(toIndentedString(this.maxRatio)).append("\n");
				sb.append("    group: ").append(toIndentedString(this.group)).append("\n");
				sb.append("}");
				return sb.toString();
			}
			
			/**
			 * Convert the given object to string with each line indented by 4 spaces
			 * (except the first line).
			 */
			private String toIndentedString(java.lang.Object o) {
				if (o == null) {
					return "null";
				}
				return o.toString().replace("\n", "\n    ");
			}
			
		}
		
		private java.lang.String name = null;
		private java.math.BigDecimal minRatio = new java.math.BigDecimal("0");
		private java.math.BigDecimal midRatio = new java.math.BigDecimal("0");
		private java.math.BigDecimal maxRatio = new java.math.BigDecimal("0");
		private java.util.List<com.example.model.SurveyReportAspectsArea.Series.Aspect> aspects = new java.util.ArrayList<com.example.model.SurveyReportAspectsArea.Series.Aspect>();
		
		/**
		 */
		public Series name(java.lang.String name) {
			setName(name);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("name")
		@javax.validation.constraints.NotNull
		public java.lang.String getName() {
			return this.name;
		}
		public void setName(java.lang.String name) {
			this.name = name;
		}
		
		/**
		 * The mean ratio across all aspects of all respondents who are in the min group.
		 */
		public Series minRatio(java.math.BigDecimal minRatio) {
			setMinRatio(minRatio);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "The mean ratio across all aspects of all respondents who are in the min group.")
		@com.fasterxml.jackson.annotation.JsonProperty("minRatio")
		@javax.validation.constraints.NotNull
		public java.math.BigDecimal getMinRatio() {
			return this.minRatio;
		}
		public void setMinRatio(java.math.BigDecimal minRatio) {
			this.minRatio = minRatio;
		}
		
		/**
		 */
		public Series midRatio(java.math.BigDecimal midRatio) {
			setMidRatio(midRatio);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("midRatio")
		@javax.validation.constraints.NotNull
		public java.math.BigDecimal getMidRatio() {
			return this.midRatio;
		}
		public void setMidRatio(java.math.BigDecimal midRatio) {
			this.midRatio = midRatio;
		}
		
		/**
		 */
		public Series maxRatio(java.math.BigDecimal maxRatio) {
			setMaxRatio(maxRatio);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("maxRatio")
		@javax.validation.constraints.NotNull
		public java.math.BigDecimal getMaxRatio() {
			return this.maxRatio;
		}
		public void setMaxRatio(java.math.BigDecimal maxRatio) {
			this.maxRatio = maxRatio;
		}
		
		/**
		 */
		public Series aspects(java.util.List<com.example.model.SurveyReportAspectsArea.Series.Aspect> aspects) {
			setAspects(aspects);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("aspects")
		@javax.validation.Valid
		@javax.validation.constraints.NotNull
		public java.util.List<com.example.model.SurveyReportAspectsArea.Series.Aspect> getAspects() {
			return this.aspects;
		}
		public void setAspects(java.util.List<com.example.model.SurveyReportAspectsArea.Series.Aspect> aspects) {
			this.aspects = aspects;
		}
		public void addAspect(com.example.model.SurveyReportAspectsArea.Series.Aspect aspect) {
			if (this.aspects == null) {
				this.aspects = new java.util.ArrayList<com.example.model.SurveyReportAspectsArea.Series.Aspect>();
			}
			this.aspects.add(aspect);
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Series series = (Series) o;
			return java.util.Objects.equals(this.name, series.name) &&
					java.util.Objects.equals(this.minRatio, series.minRatio) &&
					java.util.Objects.equals(this.midRatio, series.midRatio) &&
					java.util.Objects.equals(this.maxRatio, series.maxRatio) &&
					java.util.Objects.equals(this.aspects, series.aspects);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.name, this.minRatio, this.midRatio, this.maxRatio, this.aspects);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Series {\n");
			
			sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
			sb.append("    minRatio: ").append(toIndentedString(this.minRatio)).append("\n");
			sb.append("    midRatio: ").append(toIndentedString(this.midRatio)).append("\n");
			sb.append("    maxRatio: ").append(toIndentedString(this.maxRatio)).append("\n");
			sb.append("    aspects: ").append(toIndentedString(this.aspects)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	@io.swagger.annotations.ApiModel(value = "")
	public static class Group implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		private java.lang.String title = null;
		private java.lang.String code = null;
		
		/**
		 * The title of the group. e.g. Doing great
		 */
		public Group title(java.lang.String title) {
			setTitle(title);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "The title of the group. e.g. Doing great")
		@com.fasterxml.jackson.annotation.JsonProperty("title")
		@javax.validation.constraints.NotNull
		public java.lang.String getTitle() {
			return this.title;
		}
		public void setTitle(java.lang.String title) {
			this.title = title;
		}
		
		/**
		 * The internal code of the group, used to reference a group in an aspect.
		 */
		public Group code(java.lang.String code) {
			setCode(code);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "The internal code of the group, used to reference a group in an aspect.")
		@com.fasterxml.jackson.annotation.JsonProperty("code")
		@javax.validation.constraints.NotNull
		public java.lang.String getCode() {
			return this.code;
		}
		public void setCode(java.lang.String code) {
			this.code = code;
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Group group = (Group) o;
			return java.util.Objects.equals(this.title, group.title) &&
					java.util.Objects.equals(this.code, group.code);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.title, this.code);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Group {\n");
			
			sb.append("    title: ").append(toIndentedString(this.title)).append("\n");
			sb.append("    code: ").append(toIndentedString(this.code)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	private java.util.List<com.example.model.SurveyReportAspectsArea.Series> series = new java.util.ArrayList<com.example.model.SurveyReportAspectsArea.Series>();
	private java.util.List<com.example.model.SurveyReportAspectsArea.Group> groups = null;
	
	/**
	 */
	@java.lang.Override
	public SurveyReportAspectsArea id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyReportAspectsArea name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyReportAspectsArea description(java.lang.String description) {
		setDescription(description);
		return this;
	}
	
	/**
	 * Score between 0.0 and 1.0 representing the overall score of this area for the main series of data.
	 */
	@java.lang.Override
	public SurveyReportAspectsArea score(java.math.BigDecimal score) {
		setScore(score);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyReportAspectsArea minLabel(java.lang.String minLabel) {
		setMinLabel(minLabel);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyReportAspectsArea midLabel(java.lang.String midLabel) {
		setMidLabel(midLabel);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyReportAspectsArea maxLabel(java.lang.String maxLabel) {
		setMaxLabel(maxLabel);
		return this;
	}
	
	/**
	 * An article from the library.
	 */
	@java.lang.Override
	public SurveyReportAspectsArea article(com.example.model.Article article) {
		setArticle(article);
		return this;
	}
	
	/**
	 * analysis for the report are from Umbrella
	 */
	@java.lang.Override
	public SurveyReportAspectsArea analysis(java.lang.String analysis) {
		setAnalysis(analysis);
		return this;
	}
	
	/**
	 */
	public SurveyReportAspectsArea series(java.util.List<com.example.model.SurveyReportAspectsArea.Series> series) {
		setSeries(series);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("series")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	@javax.validation.constraints.Size(min=1)
	public java.util.List<com.example.model.SurveyReportAspectsArea.Series> getSeries() {
		return this.series;
	}
	public void setSeries(java.util.List<com.example.model.SurveyReportAspectsArea.Series> series) {
		this.series = series;
	}
	public void addSeries(com.example.model.SurveyReportAspectsArea.Series series) {
		if (this.series == null) {
			this.series = new java.util.ArrayList<com.example.model.SurveyReportAspectsArea.Series>();
		}
		this.series.add(series);
	}
	
	/**
	 */
	public SurveyReportAspectsArea groups(java.util.List<com.example.model.SurveyReportAspectsArea.Group> groups) {
		setGroups(groups);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("groups")
	@javax.validation.Valid
	public java.util.List<com.example.model.SurveyReportAspectsArea.Group> getGroups() {
		return this.groups;
	}
	public void setGroups(java.util.List<com.example.model.SurveyReportAspectsArea.Group> groups) {
		this.groups = groups;
	}
	public void addGroup(com.example.model.SurveyReportAspectsArea.Group group) {
		if (this.groups == null) {
			this.groups = new java.util.ArrayList<com.example.model.SurveyReportAspectsArea.Group>();
		}
		this.groups.add(group);
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		if (!super.equals(o)) {
			return false;
		}
		SurveyReportAspectsArea surveyReportAspectsArea = (SurveyReportAspectsArea) o;
		return java.util.Objects.equals(this.series, surveyReportAspectsArea.series) &&
				java.util.Objects.equals(this.groups, surveyReportAspectsArea.groups);
	}
	
	@Override
	public int hashCode() {
		return 31 * super.hashCode() + java.util.Objects.hash(this.series, this.groups);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class SurveyReportAspectsArea {\n");
		sb.append("    ").append(toIndentedString(super.toString())).append("\n");
		sb.append("    series: ").append(toIndentedString(this.series)).append("\n");
		sb.append("    groups: ").append(toIndentedString(this.groups)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
