package com.example.model;

/**
 * A content library topic.
 */
@io.swagger.annotations.ApiModel(value = "TopicSummary", description = "A content library topic.")
@javax.xml.bind.annotation.XmlRootElement(name = "TopicSummary")
@com.fasterxml.jackson.annotation.JsonSubTypes({
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.Topic.class, name = "Topic"),
})
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class TopicSummary implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.UUID id = null;
	private java.lang.String name = null;
	private java.lang.String description = null;
	
	/**
	 */
	public TopicSummary id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("id")
	@javax.validation.constraints.NotNull
	public java.util.UUID getId() {
		return this.id;
	}
	public void setId(java.util.UUID id) {
		this.id = id;
	}
	
	/**
	 */
	public TopicSummary name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("name")
	@javax.validation.constraints.NotNull
	public java.lang.String getName() {
		return this.name;
	}
	public void setName(java.lang.String name) {
		this.name = name;
	}
	
	/**
	 */
	public TopicSummary description(java.lang.String description) {
		setDescription(description);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("description")
	public java.lang.String getDescription() {
		return this.description;
	}
	public void setDescription(java.lang.String description) {
		this.description = description;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		TopicSummary topicSummary = (TopicSummary) o;
		return java.util.Objects.equals(this.id, topicSummary.id) &&
				java.util.Objects.equals(this.name, topicSummary.name) &&
				java.util.Objects.equals(this.description, topicSummary.description);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.id, this.name, this.description);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class TopicSummary {\n");
		
		sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
		sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
		sb.append("    description: ").append(toIndentedString(this.description)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
