package com.example.model;

@io.swagger.annotations.ApiModel(value = "")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class AddUsersRequest implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@io.swagger.annotations.ApiModel(value = "")
	public static class User implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		private java.lang.String givenName = null;
		private java.lang.String familyName = null;
		private java.lang.String emailAddress = null;
		private com.example.model.AdminUserRole adminRole = null;
		
		/**
		 */
		public User givenName(java.lang.String givenName) {
			setGivenName(givenName);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("givenName")
		@javax.validation.constraints.NotNull
		public java.lang.String getGivenName() {
			return this.givenName;
		}
		public void setGivenName(java.lang.String givenName) {
			this.givenName = givenName;
		}
		
		/**
		 */
		public User familyName(java.lang.String familyName) {
			setFamilyName(familyName);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("familyName")
		@javax.validation.constraints.NotNull
		public java.lang.String getFamilyName() {
			return this.familyName;
		}
		public void setFamilyName(java.lang.String familyName) {
			this.familyName = familyName;
		}
		
		/**
		 */
		public User emailAddress(java.lang.String emailAddress) {
			setEmailAddress(emailAddress);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("emailAddress")
		@javax.validation.constraints.NotNull
		@javax.validation.constraints.Email
		public java.lang.String getEmailAddress() {
			return this.emailAddress;
		}
		public void setEmailAddress(java.lang.String emailAddress) {
			this.emailAddress = emailAddress;
		}
		
		/**
		 */
		public User adminRole(com.example.model.AdminUserRole adminRole) {
			setAdminRole(adminRole);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("adminRole")
		@javax.validation.constraints.NotNull
		public com.example.model.AdminUserRole getAdminRole() {
			return this.adminRole;
		}
		public void setAdminRole(com.example.model.AdminUserRole adminRole) {
			this.adminRole = adminRole;
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			User user = (User) o;
			return java.util.Objects.equals(this.givenName, user.givenName) &&
					java.util.Objects.equals(this.familyName, user.familyName) &&
					java.util.Objects.equals(this.emailAddress, user.emailAddress) &&
					java.util.Objects.equals(this.adminRole, user.adminRole);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.givenName, this.familyName, this.emailAddress, this.adminRole);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class User {\n");
			
			sb.append("    givenName: ").append(toIndentedString(this.givenName)).append("\n");
			sb.append("    familyName: ").append(toIndentedString(this.familyName)).append("\n");
			sb.append("    emailAddress: ").append(toIndentedString(this.emailAddress)).append("\n");
			sb.append("    adminRole: ").append(toIndentedString(this.adminRole)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	private java.util.List<com.example.model.AddUsersRequest.User> users = null;
	
	/**
	 */
	public AddUsersRequest users(java.util.List<com.example.model.AddUsersRequest.User> users) {
		setUsers(users);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("users")
	@javax.validation.Valid
	public java.util.List<com.example.model.AddUsersRequest.User> getUsers() {
		return this.users;
	}
	public void setUsers(java.util.List<com.example.model.AddUsersRequest.User> users) {
		this.users = users;
	}
	public void addUser(com.example.model.AddUsersRequest.User user) {
		if (this.users == null) {
			this.users = new java.util.ArrayList<com.example.model.AddUsersRequest.User>();
		}
		this.users.add(user);
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		AddUsersRequest addUsersRequest = (AddUsersRequest) o;
		return java.util.Objects.equals(this.users, addUsersRequest.users);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.users);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class AddUsersRequest {\n");
		
		sb.append("    users: ").append(toIndentedString(this.users)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
