package com.example.model;

@io.swagger.annotations.ApiModel(value = "")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class ConfirmTotpRequest implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.lang.String token = null;
	private java.lang.String totpCode = null;
	
	/**
	 * The token returned from the startTotp API call
	 */
	public ConfirmTotpRequest token(java.lang.String token) {
		setToken(token);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "The token returned from the startTotp API call")
	@com.fasterxml.jackson.annotation.JsonProperty("token")
	@javax.validation.constraints.NotNull
	public java.lang.String getToken() {
		return this.token;
	}
	public void setToken(java.lang.String token) {
		this.token = token;
	}
	
	/**
	 * The current TOTP code to be entered by the user to confirm that the TOTP is working correctly.
	 */
	public ConfirmTotpRequest totpCode(java.lang.String totpCode) {
		setTotpCode(totpCode);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "The current TOTP code to be entered by the user to confirm that the TOTP is working correctly.")
	@com.fasterxml.jackson.annotation.JsonProperty("totpCode")
	@javax.validation.constraints.NotNull
	public java.lang.String getTotpCode() {
		return this.totpCode;
	}
	public void setTotpCode(java.lang.String totpCode) {
		this.totpCode = totpCode;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		ConfirmTotpRequest confirmTotpRequest = (ConfirmTotpRequest) o;
		return java.util.Objects.equals(this.token, confirmTotpRequest.token) &&
				java.util.Objects.equals(this.totpCode, confirmTotpRequest.totpCode);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.token, this.totpCode);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class ConfirmTotpRequest {\n");
		
		sb.append("    token: ").append(toIndentedString(this.token)).append("\n");
		sb.append("    totpCode: ").append(toIndentedString(this.totpCode)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
