package com.example.model;

/**
 * An image
 */
@io.swagger.annotations.ApiModel(value = "Image", description = "An image")
@javax.xml.bind.annotation.XmlRootElement(name = "Image")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class Image implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.net.URL url = null;
	private int width = 0;
	private int height = 0;
	private java.lang.String title = null;
	
	/**
	 */
	public Image url(java.net.URL url) {
		setUrl(url);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("url")
	@javax.validation.constraints.NotNull
	public java.net.URL getUrl() {
		return this.url;
	}
	public void setUrl(java.net.URL url) {
		this.url = url;
	}
	
	/**
	 */
	public Image width(int width) {
		setWidth(width);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("width")
	@javax.validation.constraints.NotNull
	public int getWidth() {
		return this.width;
	}
	public void setWidth(int width) {
		this.width = width;
	}
	
	/**
	 */
	public Image height(int height) {
		setHeight(height);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("height")
	@javax.validation.constraints.NotNull
	public int getHeight() {
		return this.height;
	}
	public void setHeight(int height) {
		this.height = height;
	}
	
	/**
	 * A description of the image to use in alt text.
	 */
	public Image title(java.lang.String title) {
		setTitle(title);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "A description of the image to use in alt text.")
	@com.fasterxml.jackson.annotation.JsonProperty("title")
	public java.lang.String getTitle() {
		return this.title;
	}
	public void setTitle(java.lang.String title) {
		this.title = title;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		Image image = (Image) o;
		return java.util.Objects.equals(this.url, image.url) &&
				java.util.Objects.equals(this.width, image.width) &&
				java.util.Objects.equals(this.height, image.height) &&
				java.util.Objects.equals(this.title, image.title);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.url, this.width, this.height, this.title);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class Image {\n");
		
		sb.append("    url: ").append(toIndentedString(this.url)).append("\n");
		sb.append("    width: ").append(toIndentedString(this.width)).append("\n");
		sb.append("    height: ").append(toIndentedString(this.height)).append("\n");
		sb.append("    title: ").append(toIndentedString(this.title)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
