package com.example.model;

@io.swagger.annotations.ApiModel(value = "ParticipationInfo")
@javax.xml.bind.annotation.XmlRootElement(name = "ParticipationInfo")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class ParticipationInfo implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.UUID participationId = null;
	private java.util.UUID surveyId = null;
	private java.lang.String name = null;
	private com.example.model.AccountSummary account = null;
	private java.util.UUID nextQuestionUUID = null;
	private java.time.OffsetDateTime whenCompleted = null;
	private java.time.OffsetDateTime whenStarted = null;
	private java.time.OffsetDateTime whenLastUpdated = null;
	private java.time.OffsetDateTime whenSurveyOpened = null;
	
	/**
	 * participation uuid
	 */
	public ParticipationInfo participationId(java.util.UUID participationId) {
		setParticipationId(participationId);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "participation uuid")
	@com.fasterxml.jackson.annotation.JsonProperty("participationId")
	@javax.validation.constraints.NotNull
	public java.util.UUID getParticipationId() {
		return this.participationId;
	}
	public void setParticipationId(java.util.UUID participationId) {
		this.participationId = participationId;
	}
	
	/**
	 * survey uuid
	 */
	public ParticipationInfo surveyId(java.util.UUID surveyId) {
		setSurveyId(surveyId);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "survey uuid")
	@com.fasterxml.jackson.annotation.JsonProperty("surveyId")
	@javax.validation.constraints.NotNull
	public java.util.UUID getSurveyId() {
		return this.surveyId;
	}
	public void setSurveyId(java.util.UUID surveyId) {
		this.surveyId = surveyId;
	}
	
	/**
	 * name of survey
	 */
	public ParticipationInfo name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "name of survey")
	@com.fasterxml.jackson.annotation.JsonProperty("name")
	@javax.validation.constraints.NotNull
	public java.lang.String getName() {
		return this.name;
	}
	public void setName(java.lang.String name) {
		this.name = name;
	}
	
	/**
	 */
	public ParticipationInfo account(com.example.model.AccountSummary account) {
		setAccount(account);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("account")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public com.example.model.AccountSummary getAccount() {
		return this.account;
	}
	public void setAccount(com.example.model.AccountSummary account) {
		this.account = account;
	}
	
	/**
	 * ongoing question to answer
	 */
	public ParticipationInfo nextQuestionUUID(java.util.UUID nextQuestionUUID) {
		setNextQuestionUUID(nextQuestionUUID);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "ongoing question to answer")
	@com.fasterxml.jackson.annotation.JsonProperty("nextQuestionUUID")
	public java.util.UUID getNextQuestionUUID() {
		return this.nextQuestionUUID;
	}
	public void setNextQuestionUUID(java.util.UUID nextQuestionUUID) {
		this.nextQuestionUUID = nextQuestionUUID;
	}
	
	/**
	 */
	public ParticipationInfo whenCompleted(java.time.OffsetDateTime whenCompleted) {
		setWhenCompleted(whenCompleted);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("whenCompleted")
	public java.time.OffsetDateTime getWhenCompleted() {
		return this.whenCompleted;
	}
	public void setWhenCompleted(java.time.OffsetDateTime whenCompleted) {
		this.whenCompleted = whenCompleted;
	}
	
	/**
	 */
	public ParticipationInfo whenStarted(java.time.OffsetDateTime whenStarted) {
		setWhenStarted(whenStarted);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("whenStarted")
	public java.time.OffsetDateTime getWhenStarted() {
		return this.whenStarted;
	}
	public void setWhenStarted(java.time.OffsetDateTime whenStarted) {
		this.whenStarted = whenStarted;
	}
	
	/**
	 */
	public ParticipationInfo whenLastUpdated(java.time.OffsetDateTime whenLastUpdated) {
		setWhenLastUpdated(whenLastUpdated);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("whenLastUpdated")
	public java.time.OffsetDateTime getWhenLastUpdated() {
		return this.whenLastUpdated;
	}
	public void setWhenLastUpdated(java.time.OffsetDateTime whenLastUpdated) {
		this.whenLastUpdated = whenLastUpdated;
	}
	
	/**
	 */
	public ParticipationInfo whenSurveyOpened(java.time.OffsetDateTime whenSurveyOpened) {
		setWhenSurveyOpened(whenSurveyOpened);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("whenSurveyOpened")
	public java.time.OffsetDateTime getWhenSurveyOpened() {
		return this.whenSurveyOpened;
	}
	public void setWhenSurveyOpened(java.time.OffsetDateTime whenSurveyOpened) {
		this.whenSurveyOpened = whenSurveyOpened;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		ParticipationInfo participationInfo = (ParticipationInfo) o;
		return java.util.Objects.equals(this.participationId, participationInfo.participationId) &&
				java.util.Objects.equals(this.surveyId, participationInfo.surveyId) &&
				java.util.Objects.equals(this.name, participationInfo.name) &&
				java.util.Objects.equals(this.account, participationInfo.account) &&
				java.util.Objects.equals(this.nextQuestionUUID, participationInfo.nextQuestionUUID) &&
				java.util.Objects.equals(this.whenCompleted, participationInfo.whenCompleted) &&
				java.util.Objects.equals(this.whenStarted, participationInfo.whenStarted) &&
				java.util.Objects.equals(this.whenLastUpdated, participationInfo.whenLastUpdated) &&
				java.util.Objects.equals(this.whenSurveyOpened, participationInfo.whenSurveyOpened);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.participationId, this.surveyId, this.name, this.account, this.nextQuestionUUID, this.whenCompleted, this.whenStarted, this.whenLastUpdated, this.whenSurveyOpened);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class ParticipationInfo {\n");
		
		sb.append("    participationId: ").append(toIndentedString(this.participationId)).append("\n");
		sb.append("    surveyId: ").append(toIndentedString(this.surveyId)).append("\n");
		sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
		sb.append("    account: ").append(toIndentedString(this.account)).append("\n");
		sb.append("    nextQuestionUUID: ").append(toIndentedString(this.nextQuestionUUID)).append("\n");
		sb.append("    whenCompleted: ").append(toIndentedString(this.whenCompleted)).append("\n");
		sb.append("    whenStarted: ").append(toIndentedString(this.whenStarted)).append("\n");
		sb.append("    whenLastUpdated: ").append(toIndentedString(this.whenLastUpdated)).append("\n");
		sb.append("    whenSurveyOpened: ").append(toIndentedString(this.whenSurveyOpened)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
