package com.example.model;

@io.swagger.annotations.ApiModel(value = "")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class PatchAccountRequest implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.lang.String name = null;
	private boolean __patchedName = false;
	private java.lang.String logo = null;
	private boolean __patchedLogo = false;
	private java.lang.String riskContactEmail = null;
	private boolean __patchedRiskContactEmail = false;
	private java.lang.Boolean disabled = null;
	private boolean __patchedDisabled = false;
	private java.lang.Boolean removeCompletedParticipations = null;
	private boolean __patchedRemoveCompletedParticipations = false;
	private java.lang.String privacyStatement = null;
	private boolean __patchedPrivacyStatement = false;
	
	/**
	 */
	public PatchAccountRequest name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("name")
	public java.lang.String getName() {
		return this.name;
	}
	public void setName(java.lang.String name) {
		this.name = name;
		this.__patchedName = true;
	}
	public boolean patchedName() {
		return this.__patchedName;
	}
	
	/**
	 * Base64 encoded string.
	 */
	public PatchAccountRequest logo(java.lang.String logo) {
		setLogo(logo);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Base64 encoded string.")
	@com.fasterxml.jackson.annotation.JsonProperty("logo")
	public java.lang.String getLogo() {
		return this.logo;
	}
	public void setLogo(java.lang.String logo) {
		this.logo = logo;
		this.__patchedLogo = true;
	}
	public boolean patchedLogo() {
		return this.__patchedLogo;
	}
	
	/**
	 */
	public PatchAccountRequest riskContactEmail(java.lang.String riskContactEmail) {
		setRiskContactEmail(riskContactEmail);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("riskContactEmail")
	@javax.validation.constraints.Email
	public java.lang.String getRiskContactEmail() {
		return this.riskContactEmail;
	}
	public void setRiskContactEmail(java.lang.String riskContactEmail) {
		this.riskContactEmail = riskContactEmail;
		this.__patchedRiskContactEmail = true;
	}
	public boolean patchedRiskContactEmail() {
		return this.__patchedRiskContactEmail;
	}
	
	/**
	 * Set whether the account is enabled or disabled.
	 */
	public PatchAccountRequest disabled(java.lang.Boolean disabled) {
		setDisabled(disabled);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Set whether the account is enabled or disabled.")
	@com.fasterxml.jackson.annotation.JsonProperty("disabled")
	public java.lang.Boolean getDisabled() {
		return this.disabled;
	}
	public void setDisabled(java.lang.Boolean disabled) {
		this.disabled = disabled;
		this.__patchedDisabled = true;
	}
	public boolean patchedDisabled() {
		return this.__patchedDisabled;
	}
	
	/**
	 * Set whether the account is allowed to remove participations that are not completed
	 */
	public PatchAccountRequest removeCompletedParticipations(java.lang.Boolean removeCompletedParticipations) {
		setRemoveCompletedParticipations(removeCompletedParticipations);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Set whether the account is allowed to remove participations that are not completed")
	@com.fasterxml.jackson.annotation.JsonProperty("removeCompletedParticipations")
	public java.lang.Boolean getRemoveCompletedParticipations() {
		return this.removeCompletedParticipations;
	}
	public void setRemoveCompletedParticipations(java.lang.Boolean removeCompletedParticipations) {
		this.removeCompletedParticipations = removeCompletedParticipations;
		this.__patchedRemoveCompletedParticipations = true;
	}
	public boolean patchedRemoveCompletedParticipations() {
		return this.__patchedRemoveCompletedParticipations;
	}
	
	/**
	 */
	public PatchAccountRequest privacyStatement(java.lang.String privacyStatement) {
		setPrivacyStatement(privacyStatement);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("privacyStatement")
	public java.lang.String getPrivacyStatement() {
		return this.privacyStatement;
	}
	public void setPrivacyStatement(java.lang.String privacyStatement) {
		this.privacyStatement = privacyStatement;
		this.__patchedPrivacyStatement = true;
	}
	public boolean patchedPrivacyStatement() {
		return this.__patchedPrivacyStatement;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		PatchAccountRequest patchAccountRequest = (PatchAccountRequest) o;
		return java.util.Objects.equals(this.name, patchAccountRequest.name) &&
				java.util.Objects.equals(this.logo, patchAccountRequest.logo) &&
				java.util.Objects.equals(this.riskContactEmail, patchAccountRequest.riskContactEmail) &&
				java.util.Objects.equals(this.disabled, patchAccountRequest.disabled) &&
				java.util.Objects.equals(this.removeCompletedParticipations, patchAccountRequest.removeCompletedParticipations) &&
				java.util.Objects.equals(this.privacyStatement, patchAccountRequest.privacyStatement);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.name, this.logo, this.riskContactEmail, this.disabled, this.removeCompletedParticipations, this.privacyStatement);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class PatchAccountRequest {\n");
		
		sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
		sb.append("    logo: ").append(toIndentedString(this.logo)).append("\n");
		sb.append("    riskContactEmail: ").append(toIndentedString(this.riskContactEmail)).append("\n");
		sb.append("    disabled: ").append(toIndentedString(this.disabled)).append("\n");
		sb.append("    removeCompletedParticipations: ").append(toIndentedString(this.removeCompletedParticipations)).append("\n");
		sb.append("    privacyStatement: ").append(toIndentedString(this.privacyStatement)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
