package com.example.model;

@io.swagger.annotations.ApiModel(value = "PersonDetails")
@javax.xml.bind.annotation.XmlRootElement(name = "PersonDetails")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class PersonDetails extends com.example.model.PersonSummary implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@io.swagger.annotations.ApiModel(value = "")
	public static class Membership implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		@javax.xml.bind.annotation.XmlType(name = "RoleEnum")
		@javax.xml.bind.annotation.XmlEnum(java.lang.String.class)
		public enum RoleEnum {
			@javax.xml.bind.annotation.XmlEnumValue("participant") PARTICIPANT("participant"), 
			@javax.xml.bind.annotation.XmlEnumValue("admin") ADMIN("admin");
			
			private java.lang.String value;
			
			RoleEnum(java.lang.String v) {
				value = v;
			}
			
			@com.fasterxml.jackson.annotation.JsonValue
			public String value() {
				return value;
			}
			
			@Override
			public String toString() {
				return String.valueOf(value);
			}
			
			public static RoleEnum fromValue(String v) {
				for (RoleEnum b : RoleEnum.values()) {
					if (String.valueOf(b.value).equals(v)) {
						return b;
					}
				}
				return null;
			}
		}
		
		private com.example.model.AccountSummary account = null;
		private com.example.model.PersonDetails.Membership.RoleEnum role = null;
		private com.example.model.AdminUserRole adminUserRole = null;
		
		/**
		 */
		public Membership account(com.example.model.AccountSummary account) {
			setAccount(account);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("account")
		@javax.validation.Valid
		@javax.validation.constraints.NotNull
		public com.example.model.AccountSummary getAccount() {
			return this.account;
		}
		public void setAccount(com.example.model.AccountSummary account) {
			this.account = account;
		}
		
		/**
		 */
		public Membership role(com.example.model.PersonDetails.Membership.RoleEnum role) {
			setRole(role);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("role")
		@javax.validation.constraints.NotNull
		public com.example.model.PersonDetails.Membership.RoleEnum getRole() {
			return this.role;
		}
		public void setRole(com.example.model.PersonDetails.Membership.RoleEnum role) {
			this.role = role;
		}
		
		/**
		 */
		public Membership adminUserRole(com.example.model.AdminUserRole adminUserRole) {
			setAdminUserRole(adminUserRole);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("adminUserRole")
		public com.example.model.AdminUserRole getAdminUserRole() {
			return this.adminUserRole;
		}
		public void setAdminUserRole(com.example.model.AdminUserRole adminUserRole) {
			this.adminUserRole = adminUserRole;
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Membership membership = (Membership) o;
			return java.util.Objects.equals(this.account, membership.account) &&
					java.util.Objects.equals(this.role, membership.role) &&
					java.util.Objects.equals(this.adminUserRole, membership.adminUserRole);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.account, this.role, this.adminUserRole);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Membership {\n");
			
			sb.append("    account: ").append(toIndentedString(this.account)).append("\n");
			sb.append("    role: ").append(toIndentedString(this.role)).append("\n");
			sb.append("    adminUserRole: ").append(toIndentedString(this.adminUserRole)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	private java.util.List<com.example.model.PersonDetails.Membership> memberships = new java.util.ArrayList<com.example.model.PersonDetails.Membership>();
	private java.lang.Boolean superAdmin = null;
	private java.lang.Boolean totp = null;
	
	/**
	 */
	@java.lang.Override
	public PersonDetails id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public PersonDetails name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public PersonDetails givenName(java.lang.String givenName) {
		setGivenName(givenName);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public PersonDetails familyName(java.lang.String familyName) {
		setFamilyName(familyName);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public PersonDetails emailAddress(java.lang.String emailAddress) {
		setEmailAddress(emailAddress);
		return this;
	}
	
	/**
	 * The accounts the person is a member of
	 */
	public PersonDetails memberships(java.util.List<com.example.model.PersonDetails.Membership> memberships) {
		setMemberships(memberships);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "The accounts the person is a member of")
	@com.fasterxml.jackson.annotation.JsonProperty("memberships")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<com.example.model.PersonDetails.Membership> getMemberships() {
		return this.memberships;
	}
	public void setMemberships(java.util.List<com.example.model.PersonDetails.Membership> memberships) {
		this.memberships = memberships;
	}
	public void addMembership(com.example.model.PersonDetails.Membership membership) {
		if (this.memberships == null) {
			this.memberships = new java.util.ArrayList<com.example.model.PersonDetails.Membership>();
		}
		this.memberships.add(membership);
	}
	
	/**
	 */
	public PersonDetails superAdmin(java.lang.Boolean superAdmin) {
		setSuperAdmin(superAdmin);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("superAdmin")
	public java.lang.Boolean getSuperAdmin() {
		return this.superAdmin;
	}
	public void setSuperAdmin(java.lang.Boolean superAdmin) {
		this.superAdmin = superAdmin;
	}
	
	/**
	 * Whether 2FA is enabled for the admin account.
	 */
	public PersonDetails totp(java.lang.Boolean totp) {
		setTotp(totp);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Whether 2FA is enabled for the admin account.")
	@com.fasterxml.jackson.annotation.JsonProperty("totp")
	public java.lang.Boolean getTotp() {
		return this.totp;
	}
	public void setTotp(java.lang.Boolean totp) {
		this.totp = totp;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		if (!super.equals(o)) {
			return false;
		}
		PersonDetails personDetails = (PersonDetails) o;
		return java.util.Objects.equals(this.memberships, personDetails.memberships) &&
				java.util.Objects.equals(this.superAdmin, personDetails.superAdmin) &&
				java.util.Objects.equals(this.totp, personDetails.totp);
	}
	
	@Override
	public int hashCode() {
		return 31 * super.hashCode() + java.util.Objects.hash(this.memberships, this.superAdmin, this.totp);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class PersonDetails {\n");
		sb.append("    ").append(toIndentedString(super.toString())).append("\n");
		sb.append("    memberships: ").append(toIndentedString(this.memberships)).append("\n");
		sb.append("    superAdmin: ").append(toIndentedString(this.superAdmin)).append("\n");
		sb.append("    totp: ").append(toIndentedString(this.totp)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
