package com.example.model;

@io.swagger.annotations.ApiModel(value = "ReportOptions")
@javax.xml.bind.annotation.XmlRootElement(name = "ReportOptions")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class ReportOptions implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.UUID compareToSurvey = null;
	private com.example.model.ReportFilter filter = null;
	private com.example.model.ReportFilter compareToFilter = null;
	private java.lang.Boolean compareToNormative = null;
	
	/**
	 * Compare to another survey.
	 */
	public ReportOptions compareToSurvey(java.util.UUID compareToSurvey) {
		setCompareToSurvey(compareToSurvey);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Compare to another survey.")
	@com.fasterxml.jackson.annotation.JsonProperty("compareToSurvey")
	public java.util.UUID getCompareToSurvey() {
		return this.compareToSurvey;
	}
	public void setCompareToSurvey(java.util.UUID compareToSurvey) {
		this.compareToSurvey = compareToSurvey;
	}
	
	/**
	 * Filter the report (including the compareToSurvey, unless compareToSurvey is provided).
	 */
	public ReportOptions filter(com.example.model.ReportFilter filter) {
		setFilter(filter);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Filter the report (including the compareToSurvey, unless compareToSurvey is provided).")
	@com.fasterxml.jackson.annotation.JsonProperty("filter")
	@javax.validation.Valid
	public com.example.model.ReportFilter getFilter() {
		return this.filter;
	}
	public void setFilter(com.example.model.ReportFilter filter) {
		this.filter = filter;
	}
	
	/**
	 * Filter the compareToSurvey results.
	 */
	public ReportOptions compareToFilter(com.example.model.ReportFilter compareToFilter) {
		setCompareToFilter(compareToFilter);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Filter the compareToSurvey results.")
	@com.fasterxml.jackson.annotation.JsonProperty("compareToFilter")
	@javax.validation.Valid
	public com.example.model.ReportFilter getCompareToFilter() {
		return this.compareToFilter;
	}
	public void setCompareToFilter(com.example.model.ReportFilter compareToFilter) {
		this.compareToFilter = compareToFilter;
	}
	
	/**
	 */
	public ReportOptions compareToNormative(java.lang.Boolean compareToNormative) {
		setCompareToNormative(compareToNormative);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("compareToNormative")
	public java.lang.Boolean getCompareToNormative() {
		return this.compareToNormative;
	}
	public void setCompareToNormative(java.lang.Boolean compareToNormative) {
		this.compareToNormative = compareToNormative;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		ReportOptions reportOptions = (ReportOptions) o;
		return java.util.Objects.equals(this.compareToSurvey, reportOptions.compareToSurvey) &&
				java.util.Objects.equals(this.filter, reportOptions.filter) &&
				java.util.Objects.equals(this.compareToFilter, reportOptions.compareToFilter) &&
				java.util.Objects.equals(this.compareToNormative, reportOptions.compareToNormative);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.compareToSurvey, this.filter, this.compareToFilter, this.compareToNormative);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class ReportOptions {\n");
		
		sb.append("    compareToSurvey: ").append(toIndentedString(this.compareToSurvey)).append("\n");
		sb.append("    filter: ").append(toIndentedString(this.filter)).append("\n");
		sb.append("    compareToFilter: ").append(toIndentedString(this.compareToFilter)).append("\n");
		sb.append("    compareToNormative: ").append(toIndentedString(this.compareToNormative)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
