package com.example.model;

@io.swagger.annotations.ApiModel(value = "SurveyReport")
@javax.xml.bind.annotation.XmlRootElement(name = "SurveyReport")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class SurveyReport extends com.example.model.SurveyReportSummary implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@io.swagger.annotations.ApiModel(value = "")
	public static class Section implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		@io.swagger.annotations.ApiModel(value = "")
		public static class Summaries implements java.io.Serializable {
		
			private static final long serialVersionUID = 1L;
			private java.util.List<com.example.model.SurveyReportSectionSummaryItem> best = new java.util.ArrayList<com.example.model.SurveyReportSectionSummaryItem>();
			private java.util.List<com.example.model.SurveyReportSectionSummaryItem> worst = new java.util.ArrayList<com.example.model.SurveyReportSectionSummaryItem>();
			
			/**
			 */
			public Summaries best(java.util.List<com.example.model.SurveyReportSectionSummaryItem> best) {
				setBest(best);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("best")
			@javax.validation.Valid
			@javax.validation.constraints.NotNull
			public java.util.List<com.example.model.SurveyReportSectionSummaryItem> getBest() {
				return this.best;
			}
			public void setBest(java.util.List<com.example.model.SurveyReportSectionSummaryItem> best) {
				this.best = best;
			}
			public void addBest(com.example.model.SurveyReportSectionSummaryItem best) {
				if (this.best == null) {
					this.best = new java.util.ArrayList<com.example.model.SurveyReportSectionSummaryItem>();
				}
				this.best.add(best);
			}
			
			/**
			 */
			public Summaries worst(java.util.List<com.example.model.SurveyReportSectionSummaryItem> worst) {
				setWorst(worst);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("worst")
			@javax.validation.Valid
			@javax.validation.constraints.NotNull
			public java.util.List<com.example.model.SurveyReportSectionSummaryItem> getWorst() {
				return this.worst;
			}
			public void setWorst(java.util.List<com.example.model.SurveyReportSectionSummaryItem> worst) {
				this.worst = worst;
			}
			public void addWorst(com.example.model.SurveyReportSectionSummaryItem worst) {
				if (this.worst == null) {
					this.worst = new java.util.ArrayList<com.example.model.SurveyReportSectionSummaryItem>();
				}
				this.worst.add(worst);
			}
			
			@Override
			public boolean equals(java.lang.Object o) {
				if (this == o) {
					return true;
				}
				if (o == null || getClass() != o.getClass()) {
					return false;
				}
				Summaries summaries = (Summaries) o;
				return java.util.Objects.equals(this.best, summaries.best) &&
						java.util.Objects.equals(this.worst, summaries.worst);
			}
			
			@Override
			public int hashCode() {
				return java.util.Objects.hash(this.best, this.worst);
			}
			
			@Override
			public String toString() {
				StringBuilder sb = new StringBuilder();
				sb.append("class Summaries {\n");
				
				sb.append("    best: ").append(toIndentedString(this.best)).append("\n");
				sb.append("    worst: ").append(toIndentedString(this.worst)).append("\n");
				sb.append("}");
				return sb.toString();
			}
			
			/**
			 * Convert the given object to string with each line indented by 4 spaces
			 * (except the first line).
			 */
			private String toIndentedString(java.lang.Object o) {
				if (o == null) {
					return "null";
				}
				return o.toString().replace("\n", "\n    ");
			}
			
		}
		
		private java.util.UUID id = null;
		private java.lang.String name = null;
		private java.math.BigDecimal score = null;
		private java.util.List<java.math.BigDecimal> compareToScores = null;
		private java.lang.String description = null;
		private com.example.model.Article article = null;
		private com.example.model.SurveyReport.Section.Summaries summaries = null;
		private java.util.List<com.example.model.SurveyReportArea> areas = new java.util.ArrayList<com.example.model.SurveyReportArea>();
		
		/**
		 */
		public Section id(java.util.UUID id) {
			setId(id);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("id")
		@javax.validation.constraints.NotNull
		public java.util.UUID getId() {
			return this.id;
		}
		public void setId(java.util.UUID id) {
			this.id = id;
		}
		
		/**
		 */
		public Section name(java.lang.String name) {
			setName(name);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("name")
		@javax.validation.constraints.NotNull
		public java.lang.String getName() {
			return this.name;
		}
		public void setName(java.lang.String name) {
			this.name = name;
		}
		
		/**
		 * Score between 0.0 and 1.0
		 */
		public Section score(java.math.BigDecimal score) {
			setScore(score);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "Score between 0.0 and 1.0")
		@com.fasterxml.jackson.annotation.JsonProperty("score")
		public java.math.BigDecimal getScore() {
			return this.score;
		}
		public void setScore(java.math.BigDecimal score) {
			this.score = score;
		}
		
		/**
		 * if comparing to another surveys and/or normative the array would contain corresponding scores
		 */
		public Section compareToScores(java.util.List<java.math.BigDecimal> compareToScores) {
			setCompareToScores(compareToScores);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "if comparing to another surveys and/or normative the array would contain corresponding scores")
		@com.fasterxml.jackson.annotation.JsonProperty("compareToScores")
		@javax.validation.Valid
		public java.util.List<java.math.BigDecimal> getCompareToScores() {
			return this.compareToScores;
		}
		public void setCompareToScores(java.util.List<java.math.BigDecimal> compareToScores) {
			this.compareToScores = compareToScores;
		}
		public void addCompareToScore(java.math.BigDecimal compareToScore) {
			if (this.compareToScores == null) {
				this.compareToScores = new java.util.ArrayList<java.math.BigDecimal>();
			}
			this.compareToScores.add(compareToScore);
		}
		
		/**
		 * survey section description
		 */
		public Section description(java.lang.String description) {
			setDescription(description);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "survey section description")
		@com.fasterxml.jackson.annotation.JsonProperty("description")
		public java.lang.String getDescription() {
			return this.description;
		}
		public void setDescription(java.lang.String description) {
			this.description = description;
		}
		
		/**
		 * An article from the library.
		 */
		public Section article(com.example.model.Article article) {
			setArticle(article);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "An article from the library.")
		@com.fasterxml.jackson.annotation.JsonProperty("article")
		@javax.validation.Valid
		public com.example.model.Article getArticle() {
			return this.article;
		}
		public void setArticle(com.example.model.Article article) {
			this.article = article;
		}
		
		/**
		 */
		public Section summaries(com.example.model.SurveyReport.Section.Summaries summaries) {
			setSummaries(summaries);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("summaries")
		@javax.validation.Valid
		public com.example.model.SurveyReport.Section.Summaries getSummaries() {
			return this.summaries;
		}
		public void setSummaries(com.example.model.SurveyReport.Section.Summaries summaries) {
			this.summaries = summaries;
		}
		
		/**
		 */
		public Section areas(java.util.List<com.example.model.SurveyReportArea> areas) {
			setAreas(areas);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("areas")
		@javax.validation.Valid
		@javax.validation.constraints.NotNull
		public java.util.List<com.example.model.SurveyReportArea> getAreas() {
			return this.areas;
		}
		public void setAreas(java.util.List<com.example.model.SurveyReportArea> areas) {
			this.areas = areas;
		}
		public void addArea(com.example.model.SurveyReportArea area) {
			if (this.areas == null) {
				this.areas = new java.util.ArrayList<com.example.model.SurveyReportArea>();
			}
			this.areas.add(area);
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Section section = (Section) o;
			return java.util.Objects.equals(this.id, section.id) &&
					java.util.Objects.equals(this.name, section.name) &&
					java.util.Objects.equals(this.score, section.score) &&
					java.util.Objects.equals(this.compareToScores, section.compareToScores) &&
					java.util.Objects.equals(this.description, section.description) &&
					java.util.Objects.equals(this.article, section.article) &&
					java.util.Objects.equals(this.summaries, section.summaries) &&
					java.util.Objects.equals(this.areas, section.areas);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.id, this.name, this.score, this.compareToScores, this.description, this.article, this.summaries, this.areas);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Section {\n");
			
			sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
			sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
			sb.append("    score: ").append(toIndentedString(this.score)).append("\n");
			sb.append("    compareToScores: ").append(toIndentedString(this.compareToScores)).append("\n");
			sb.append("    description: ").append(toIndentedString(this.description)).append("\n");
			sb.append("    article: ").append(toIndentedString(this.article)).append("\n");
			sb.append("    summaries: ").append(toIndentedString(this.summaries)).append("\n");
			sb.append("    areas: ").append(toIndentedString(this.areas)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	private com.example.model.SurveyDetails otherSurveyDetails = null;
	private java.lang.String minLabel = null;
	private java.lang.String midLabel = null;
	private java.lang.String maxLabel = null;
	private com.example.model.Article article = null;
	private java.lang.String executiveSummary = null;
	private java.util.List<java.math.BigDecimal> compareToScores = null;
	private java.util.List<com.example.model.SurveyReport.Section> sections = new java.util.ArrayList<com.example.model.SurveyReport.Section>();
	
	/**
	 * the name of survey this report is for
	 */
	@java.lang.Override
	public SurveyReport surveyName(java.lang.String surveyName) {
		setSurveyName(surveyName);
		return this;
	}
	
	/**
	 * Score between 0.0 and 1.0
	 */
	@java.lang.Override
	public SurveyReport score(java.math.BigDecimal score) {
		setScore(score);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyReport details(com.example.model.SurveyDetails details) {
		setDetails(details);
		return this;
	}
	
	/**
	 * If comparing to another survey, this contains the other survey details.
	 */
	public SurveyReport otherSurveyDetails(com.example.model.SurveyDetails otherSurveyDetails) {
		setOtherSurveyDetails(otherSurveyDetails);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "If comparing to another survey, this contains the other survey details.")
	@com.fasterxml.jackson.annotation.JsonProperty("otherSurveyDetails")
	@javax.validation.Valid
	public com.example.model.SurveyDetails getOtherSurveyDetails() {
		return this.otherSurveyDetails;
	}
	public void setOtherSurveyDetails(com.example.model.SurveyDetails otherSurveyDetails) {
		this.otherSurveyDetails = otherSurveyDetails;
	}
	
	/**
	 */
	public SurveyReport minLabel(java.lang.String minLabel) {
		setMinLabel(minLabel);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("minLabel")
	public java.lang.String getMinLabel() {
		return this.minLabel;
	}
	public void setMinLabel(java.lang.String minLabel) {
		this.minLabel = minLabel;
	}
	
	/**
	 */
	public SurveyReport midLabel(java.lang.String midLabel) {
		setMidLabel(midLabel);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("midLabel")
	public java.lang.String getMidLabel() {
		return this.midLabel;
	}
	public void setMidLabel(java.lang.String midLabel) {
		this.midLabel = midLabel;
	}
	
	/**
	 */
	public SurveyReport maxLabel(java.lang.String maxLabel) {
		setMaxLabel(maxLabel);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("maxLabel")
	public java.lang.String getMaxLabel() {
		return this.maxLabel;
	}
	public void setMaxLabel(java.lang.String maxLabel) {
		this.maxLabel = maxLabel;
	}
	
	/**
	 * An article from the library.
	 */
	public SurveyReport article(com.example.model.Article article) {
		setArticle(article);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "An article from the library.")
	@com.fasterxml.jackson.annotation.JsonProperty("article")
	@javax.validation.Valid
	public com.example.model.Article getArticle() {
		return this.article;
	}
	public void setArticle(com.example.model.Article article) {
		this.article = article;
	}
	
	/**
	 * survey executive summary by Umbrella
	 */
	public SurveyReport executiveSummary(java.lang.String executiveSummary) {
		setExecutiveSummary(executiveSummary);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "survey executive summary by Umbrella")
	@com.fasterxml.jackson.annotation.JsonProperty("executiveSummary")
	public java.lang.String getExecutiveSummary() {
		return this.executiveSummary;
	}
	public void setExecutiveSummary(java.lang.String executiveSummary) {
		this.executiveSummary = executiveSummary;
	}
	
	/**
	 * if comparing to another surveys and/or normative the array would contain corresponding scores
	 */
	public SurveyReport compareToScores(java.util.List<java.math.BigDecimal> compareToScores) {
		setCompareToScores(compareToScores);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "if comparing to another surveys and/or normative the array would contain corresponding scores")
	@com.fasterxml.jackson.annotation.JsonProperty("compareToScores")
	@javax.validation.Valid
	public java.util.List<java.math.BigDecimal> getCompareToScores() {
		return this.compareToScores;
	}
	public void setCompareToScores(java.util.List<java.math.BigDecimal> compareToScores) {
		this.compareToScores = compareToScores;
	}
	public void addCompareToScore(java.math.BigDecimal compareToScore) {
		if (this.compareToScores == null) {
			this.compareToScores = new java.util.ArrayList<java.math.BigDecimal>();
		}
		this.compareToScores.add(compareToScore);
	}
	
	/**
	 */
	public SurveyReport sections(java.util.List<com.example.model.SurveyReport.Section> sections) {
		setSections(sections);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("sections")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<com.example.model.SurveyReport.Section> getSections() {
		return this.sections;
	}
	public void setSections(java.util.List<com.example.model.SurveyReport.Section> sections) {
		this.sections = sections;
	}
	public void addSection(com.example.model.SurveyReport.Section section) {
		if (this.sections == null) {
			this.sections = new java.util.ArrayList<com.example.model.SurveyReport.Section>();
		}
		this.sections.add(section);
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		if (!super.equals(o)) {
			return false;
		}
		SurveyReport surveyReport = (SurveyReport) o;
		return java.util.Objects.equals(this.otherSurveyDetails, surveyReport.otherSurveyDetails) &&
				java.util.Objects.equals(this.minLabel, surveyReport.minLabel) &&
				java.util.Objects.equals(this.midLabel, surveyReport.midLabel) &&
				java.util.Objects.equals(this.maxLabel, surveyReport.maxLabel) &&
				java.util.Objects.equals(this.article, surveyReport.article) &&
				java.util.Objects.equals(this.executiveSummary, surveyReport.executiveSummary) &&
				java.util.Objects.equals(this.compareToScores, surveyReport.compareToScores) &&
				java.util.Objects.equals(this.sections, surveyReport.sections);
	}
	
	@Override
	public int hashCode() {
		return 31 * super.hashCode() + java.util.Objects.hash(this.otherSurveyDetails, this.minLabel, this.midLabel, this.maxLabel, this.article, this.executiveSummary, this.compareToScores, this.sections);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class SurveyReport {\n");
		sb.append("    ").append(toIndentedString(super.toString())).append("\n");
		sb.append("    otherSurveyDetails: ").append(toIndentedString(this.otherSurveyDetails)).append("\n");
		sb.append("    minLabel: ").append(toIndentedString(this.minLabel)).append("\n");
		sb.append("    midLabel: ").append(toIndentedString(this.midLabel)).append("\n");
		sb.append("    maxLabel: ").append(toIndentedString(this.maxLabel)).append("\n");
		sb.append("    article: ").append(toIndentedString(this.article)).append("\n");
		sb.append("    executiveSummary: ").append(toIndentedString(this.executiveSummary)).append("\n");
		sb.append("    compareToScores: ").append(toIndentedString(this.compareToScores)).append("\n");
		sb.append("    sections: ").append(toIndentedString(this.sections)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
