package com.example.model;

@io.swagger.annotations.ApiModel(value = "SurveyReportDataArea")
@javax.xml.bind.annotation.XmlRootElement(name = "SurveyReportDataArea")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class SurveyReportDataArea extends com.example.model.SurveyReportArea implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@io.swagger.annotations.ApiModel(value = "")
	public static class Series implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		@javax.xml.bind.annotation.XmlType(name = "StyleEnum")
		@javax.xml.bind.annotation.XmlEnum(java.lang.String.class)
		public enum StyleEnum {
			@javax.xml.bind.annotation.XmlEnumValue("BARS") BARS("BARS"), 
			@javax.xml.bind.annotation.XmlEnumValue("LINE") LINE("LINE"), 
			@javax.xml.bind.annotation.XmlEnumValue("HIDE") HIDE("HIDE");
			
			private java.lang.String value;
			
			StyleEnum(java.lang.String v) {
				value = v;
			}
			
			@com.fasterxml.jackson.annotation.JsonValue
			public String value() {
				return value;
			}
			
			@Override
			public String toString() {
				return String.valueOf(value);
			}
			
			public static StyleEnum fromValue(String v) {
				for (StyleEnum b : StyleEnum.values()) {
					if (String.valueOf(b.value).equals(v)) {
						return b;
					}
				}
				return null;
			}
		}
		
		@io.swagger.annotations.ApiModel(value = "")
		public static class Datum implements java.io.Serializable {
		
			private static final long serialVersionUID = 1L;
			private java.math.BigDecimal x = new java.math.BigDecimal("0");
			private java.math.BigDecimal y = new java.math.BigDecimal("0");
			private java.lang.String label = null;
			private java.math.BigDecimal score = null;
			
			/**
			 */
			public Datum x(java.math.BigDecimal x) {
				setX(x);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("x")
			@javax.validation.constraints.NotNull
			public java.math.BigDecimal getX() {
				return this.x;
			}
			public void setX(java.math.BigDecimal x) {
				this.x = x;
			}
			
			/**
			 */
			public Datum y(java.math.BigDecimal y) {
				setY(y);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("y")
			@javax.validation.constraints.NotNull
			public java.math.BigDecimal getY() {
				return this.y;
			}
			public void setY(java.math.BigDecimal y) {
				this.y = y;
			}
			
			/**
			 */
			public Datum label(java.lang.String label) {
				setLabel(label);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("label")
			public java.lang.String getLabel() {
				return this.label;
			}
			public void setLabel(java.lang.String label) {
				this.label = label;
			}
			
			/**
			 * Score between 0.0 and 1.0 representing the score for this bar. The score can be used to derive a colour, such as from the speedometer graph.
			 */
			public Datum score(java.math.BigDecimal score) {
				setScore(score);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(value = "Score between 0.0 and 1.0 representing the score for this bar. The score can be used to derive a colour, such as from the speedometer graph.")
			@com.fasterxml.jackson.annotation.JsonProperty("score")
			public java.math.BigDecimal getScore() {
				return this.score;
			}
			public void setScore(java.math.BigDecimal score) {
				this.score = score;
			}
			
			@Override
			public boolean equals(java.lang.Object o) {
				if (this == o) {
					return true;
				}
				if (o == null || getClass() != o.getClass()) {
					return false;
				}
				Datum datum = (Datum) o;
				return java.util.Objects.equals(this.x, datum.x) &&
						java.util.Objects.equals(this.y, datum.y) &&
						java.util.Objects.equals(this.label, datum.label) &&
						java.util.Objects.equals(this.score, datum.score);
			}
			
			@Override
			public int hashCode() {
				return java.util.Objects.hash(this.x, this.y, this.label, this.score);
			}
			
			@Override
			public String toString() {
				StringBuilder sb = new StringBuilder();
				sb.append("class Datum {\n");
				
				sb.append("    x: ").append(toIndentedString(this.x)).append("\n");
				sb.append("    y: ").append(toIndentedString(this.y)).append("\n");
				sb.append("    label: ").append(toIndentedString(this.label)).append("\n");
				sb.append("    score: ").append(toIndentedString(this.score)).append("\n");
				sb.append("}");
				return sb.toString();
			}
			
			/**
			 * Convert the given object to string with each line indented by 4 spaces
			 * (except the first line).
			 */
			private String toIndentedString(java.lang.Object o) {
				if (o == null) {
					return "null";
				}
				return o.toString().replace("\n", "\n    ");
			}
			
		}
		
		private java.lang.String name = null;
		private java.math.BigDecimal score = null;
		private com.example.model.SurveyReportDataArea.Series.StyleEnum style = null;
		private java.math.BigDecimal minRatio = new java.math.BigDecimal("0");
		private java.math.BigDecimal midRatio = new java.math.BigDecimal("0");
		private java.math.BigDecimal maxRatio = new java.math.BigDecimal("0");
		private java.util.List<com.example.model.SurveyReportDataArea.Series.Datum> data = new java.util.ArrayList<com.example.model.SurveyReportDataArea.Series.Datum>();
		
		/**
		 */
		public Series name(java.lang.String name) {
			setName(name);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("name")
		@javax.validation.constraints.NotNull
		public java.lang.String getName() {
			return this.name;
		}
		public void setName(java.lang.String name) {
			this.name = name;
		}
		
		/**
		 * Score between 0.0 and 1.0 representing the overall score of this series at the area level.
		
		The first series will match the score at the area level.
		
		 */
		public Series score(java.math.BigDecimal score) {
			setScore(score);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "Score between 0.0 and 1.0 representing the overall score of this series at the area level.\n\nThe first series will match the score at the area level.\n")
		@com.fasterxml.jackson.annotation.JsonProperty("score")
		public java.math.BigDecimal getScore() {
			return this.score;
		}
		public void setScore(java.math.BigDecimal score) {
			this.score = score;
		}
		
		/**
		 * The style of graph to use.
		 */
		public Series style(com.example.model.SurveyReportDataArea.Series.StyleEnum style) {
			setStyle(style);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "The style of graph to use.")
		@com.fasterxml.jackson.annotation.JsonProperty("style")
		@javax.validation.constraints.NotNull
		public com.example.model.SurveyReportDataArea.Series.StyleEnum getStyle() {
			return this.style;
		}
		public void setStyle(com.example.model.SurveyReportDataArea.Series.StyleEnum style) {
			this.style = style;
		}
		
		/**
		 * The mean ratio across all aspects of all respondents who are in the min group.
		 */
		public Series minRatio(java.math.BigDecimal minRatio) {
			setMinRatio(minRatio);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "The mean ratio across all aspects of all respondents who are in the min group.")
		@com.fasterxml.jackson.annotation.JsonProperty("minRatio")
		@javax.validation.constraints.NotNull
		public java.math.BigDecimal getMinRatio() {
			return this.minRatio;
		}
		public void setMinRatio(java.math.BigDecimal minRatio) {
			this.minRatio = minRatio;
		}
		
		/**
		 */
		public Series midRatio(java.math.BigDecimal midRatio) {
			setMidRatio(midRatio);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("midRatio")
		@javax.validation.constraints.NotNull
		public java.math.BigDecimal getMidRatio() {
			return this.midRatio;
		}
		public void setMidRatio(java.math.BigDecimal midRatio) {
			this.midRatio = midRatio;
		}
		
		/**
		 */
		public Series maxRatio(java.math.BigDecimal maxRatio) {
			setMaxRatio(maxRatio);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("maxRatio")
		@javax.validation.constraints.NotNull
		public java.math.BigDecimal getMaxRatio() {
			return this.maxRatio;
		}
		public void setMaxRatio(java.math.BigDecimal maxRatio) {
			this.maxRatio = maxRatio;
		}
		
		/**
		 */
		public Series data(java.util.List<com.example.model.SurveyReportDataArea.Series.Datum> data) {
			setData(data);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("data")
		@javax.validation.Valid
		@javax.validation.constraints.NotNull
		public java.util.List<com.example.model.SurveyReportDataArea.Series.Datum> getData() {
			return this.data;
		}
		public void setData(java.util.List<com.example.model.SurveyReportDataArea.Series.Datum> data) {
			this.data = data;
		}
		public void addDatum(com.example.model.SurveyReportDataArea.Series.Datum datum) {
			if (this.data == null) {
				this.data = new java.util.ArrayList<com.example.model.SurveyReportDataArea.Series.Datum>();
			}
			this.data.add(datum);
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Series series = (Series) o;
			return java.util.Objects.equals(this.name, series.name) &&
					java.util.Objects.equals(this.score, series.score) &&
					java.util.Objects.equals(this.style, series.style) &&
					java.util.Objects.equals(this.minRatio, series.minRatio) &&
					java.util.Objects.equals(this.midRatio, series.midRatio) &&
					java.util.Objects.equals(this.maxRatio, series.maxRatio) &&
					java.util.Objects.equals(this.data, series.data);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.name, this.score, this.style, this.minRatio, this.midRatio, this.maxRatio, this.data);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Series {\n");
			
			sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
			sb.append("    score: ").append(toIndentedString(this.score)).append("\n");
			sb.append("    style: ").append(toIndentedString(this.style)).append("\n");
			sb.append("    minRatio: ").append(toIndentedString(this.minRatio)).append("\n");
			sb.append("    midRatio: ").append(toIndentedString(this.midRatio)).append("\n");
			sb.append("    maxRatio: ").append(toIndentedString(this.maxRatio)).append("\n");
			sb.append("    data: ").append(toIndentedString(this.data)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	private com.example.model.DataAxis xAxis = null;
	private com.example.model.DataAxis yAxis = null;
	private java.util.List<com.example.model.SurveyReportDataArea.Series> series = new java.util.ArrayList<com.example.model.SurveyReportDataArea.Series>();
	
	/**
	 */
	@java.lang.Override
	public SurveyReportDataArea id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyReportDataArea name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyReportDataArea description(java.lang.String description) {
		setDescription(description);
		return this;
	}
	
	/**
	 * Score between 0.0 and 1.0 representing the overall score of this area for the main series of data.
	 */
	@java.lang.Override
	public SurveyReportDataArea score(java.math.BigDecimal score) {
		setScore(score);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyReportDataArea minLabel(java.lang.String minLabel) {
		setMinLabel(minLabel);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyReportDataArea midLabel(java.lang.String midLabel) {
		setMidLabel(midLabel);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyReportDataArea maxLabel(java.lang.String maxLabel) {
		setMaxLabel(maxLabel);
		return this;
	}
	
	/**
	 * An article from the library.
	 */
	@java.lang.Override
	public SurveyReportDataArea article(com.example.model.Article article) {
		setArticle(article);
		return this;
	}
	
	/**
	 * analysis for the report are from Umbrella
	 */
	@java.lang.Override
	public SurveyReportDataArea analysis(java.lang.String analysis) {
		setAnalysis(analysis);
		return this;
	}
	
	/**
	 */
	public SurveyReportDataArea xAxis(com.example.model.DataAxis xAxis) {
		setXAxis(xAxis);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("xAxis")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public com.example.model.DataAxis getXAxis() {
		return this.xAxis;
	}
	public void setXAxis(com.example.model.DataAxis xAxis) {
		this.xAxis = xAxis;
	}
	
	/**
	 */
	public SurveyReportDataArea yAxis(com.example.model.DataAxis yAxis) {
		setYAxis(yAxis);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("yAxis")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public com.example.model.DataAxis getYAxis() {
		return this.yAxis;
	}
	public void setYAxis(com.example.model.DataAxis yAxis) {
		this.yAxis = yAxis;
	}
	
	/**
	 */
	public SurveyReportDataArea series(java.util.List<com.example.model.SurveyReportDataArea.Series> series) {
		setSeries(series);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("series")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	@javax.validation.constraints.Size(min=1)
	public java.util.List<com.example.model.SurveyReportDataArea.Series> getSeries() {
		return this.series;
	}
	public void setSeries(java.util.List<com.example.model.SurveyReportDataArea.Series> series) {
		this.series = series;
	}
	public void addSeries(com.example.model.SurveyReportDataArea.Series series) {
		if (this.series == null) {
			this.series = new java.util.ArrayList<com.example.model.SurveyReportDataArea.Series>();
		}
		this.series.add(series);
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		if (!super.equals(o)) {
			return false;
		}
		SurveyReportDataArea surveyReportDataArea = (SurveyReportDataArea) o;
		return java.util.Objects.equals(this.xAxis, surveyReportDataArea.xAxis) &&
				java.util.Objects.equals(this.yAxis, surveyReportDataArea.yAxis) &&
				java.util.Objects.equals(this.series, surveyReportDataArea.series);
	}
	
	@Override
	public int hashCode() {
		return 31 * super.hashCode() + java.util.Objects.hash(this.xAxis, this.yAxis, this.series);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class SurveyReportDataArea {\n");
		sb.append("    ").append(toIndentedString(super.toString())).append("\n");
		sb.append("    xAxis: ").append(toIndentedString(this.xAxis)).append("\n");
		sb.append("    yAxis: ").append(toIndentedString(this.yAxis)).append("\n");
		sb.append("    series: ").append(toIndentedString(this.series)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
