package com.example.model;

@io.swagger.annotations.ApiModel(value = "SurveyReportUpdate")
@javax.xml.bind.annotation.XmlRootElement(name = "SurveyReportUpdate")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class SurveyReportUpdate implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@io.swagger.annotations.ApiModel(value = "")
	public static class Section implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		@io.swagger.annotations.ApiModel(value = "")
		public static class Area implements java.io.Serializable {
		
			private static final long serialVersionUID = 1L;
			private java.util.UUID id = null;
			private java.lang.String analysis = null;
			
			/**
			 */
			public Area id(java.util.UUID id) {
				setId(id);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("id")
			@javax.validation.constraints.NotNull
			public java.util.UUID getId() {
				return this.id;
			}
			public void setId(java.util.UUID id) {
				this.id = id;
			}
			
			/**
			 * analysis for the report are from Umbrella
			 */
			public Area analysis(java.lang.String analysis) {
				setAnalysis(analysis);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(value = "analysis for the report are from Umbrella")
			@com.fasterxml.jackson.annotation.JsonProperty("analysis")
			public java.lang.String getAnalysis() {
				return this.analysis;
			}
			public void setAnalysis(java.lang.String analysis) {
				this.analysis = analysis;
			}
			
			@Override
			public boolean equals(java.lang.Object o) {
				if (this == o) {
					return true;
				}
				if (o == null || getClass() != o.getClass()) {
					return false;
				}
				Area area = (Area) o;
				return java.util.Objects.equals(this.id, area.id) &&
						java.util.Objects.equals(this.analysis, area.analysis);
			}
			
			@Override
			public int hashCode() {
				return java.util.Objects.hash(this.id, this.analysis);
			}
			
			@Override
			public String toString() {
				StringBuilder sb = new StringBuilder();
				sb.append("class Area {\n");
				
				sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
				sb.append("    analysis: ").append(toIndentedString(this.analysis)).append("\n");
				sb.append("}");
				return sb.toString();
			}
			
			/**
			 * Convert the given object to string with each line indented by 4 spaces
			 * (except the first line).
			 */
			private String toIndentedString(java.lang.Object o) {
				if (o == null) {
					return "null";
				}
				return o.toString().replace("\n", "\n    ");
			}
			
		}
		
		private java.util.UUID id = null;
		private java.util.List<com.example.model.SurveyReportUpdate.Section.Area> areas = null;
		
		/**
		 */
		public Section id(java.util.UUID id) {
			setId(id);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("id")
		@javax.validation.constraints.NotNull
		public java.util.UUID getId() {
			return this.id;
		}
		public void setId(java.util.UUID id) {
			this.id = id;
		}
		
		/**
		 */
		public Section areas(java.util.List<com.example.model.SurveyReportUpdate.Section.Area> areas) {
			setAreas(areas);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("areas")
		@javax.validation.Valid
		public java.util.List<com.example.model.SurveyReportUpdate.Section.Area> getAreas() {
			return this.areas;
		}
		public void setAreas(java.util.List<com.example.model.SurveyReportUpdate.Section.Area> areas) {
			this.areas = areas;
		}
		public void addArea(com.example.model.SurveyReportUpdate.Section.Area area) {
			if (this.areas == null) {
				this.areas = new java.util.ArrayList<com.example.model.SurveyReportUpdate.Section.Area>();
			}
			this.areas.add(area);
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Section section = (Section) o;
			return java.util.Objects.equals(this.id, section.id) &&
					java.util.Objects.equals(this.areas, section.areas);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.id, this.areas);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Section {\n");
			
			sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
			sb.append("    areas: ").append(toIndentedString(this.areas)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	private java.lang.String executiveSummary = null;
	private boolean __patchedExecutiveSummary = false;
	private java.util.List<com.example.model.SurveyReportUpdate.Section> sections = null;
	private boolean __patchedSections = false;
	
	/**
	 * survey executive summary by Umbrella
	 */
	public SurveyReportUpdate executiveSummary(java.lang.String executiveSummary) {
		setExecutiveSummary(executiveSummary);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "survey executive summary by Umbrella")
	@com.fasterxml.jackson.annotation.JsonProperty("executiveSummary")
	public java.lang.String getExecutiveSummary() {
		return this.executiveSummary;
	}
	public void setExecutiveSummary(java.lang.String executiveSummary) {
		this.executiveSummary = executiveSummary;
		this.__patchedExecutiveSummary = true;
	}
	public boolean patchedExecutiveSummary() {
		return this.__patchedExecutiveSummary;
	}
	
	/**
	 */
	public SurveyReportUpdate sections(java.util.List<com.example.model.SurveyReportUpdate.Section> sections) {
		setSections(sections);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("sections")
	@javax.validation.Valid
	public java.util.List<com.example.model.SurveyReportUpdate.Section> getSections() {
		return this.sections;
	}
	public void setSections(java.util.List<com.example.model.SurveyReportUpdate.Section> sections) {
		this.sections = sections;
		this.__patchedSections = true;
	}
	public boolean patchedSections() {
		return this.__patchedSections;
	}
	public void addSection(com.example.model.SurveyReportUpdate.Section section) {
		if (this.sections == null) {
			this.sections = new java.util.ArrayList<com.example.model.SurveyReportUpdate.Section>();
		}
		this.sections.add(section);
		this.__patchedSections = true;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		SurveyReportUpdate surveyReportUpdate = (SurveyReportUpdate) o;
		return java.util.Objects.equals(this.executiveSummary, surveyReportUpdate.executiveSummary) &&
				java.util.Objects.equals(this.sections, surveyReportUpdate.sections);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.executiveSummary, this.sections);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class SurveyReportUpdate {\n");
		
		sb.append("    executiveSummary: ").append(toIndentedString(this.executiveSummary)).append("\n");
		sb.append("    sections: ").append(toIndentedString(this.sections)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
