package com.example.model;

@io.swagger.annotations.ApiModel(value = "")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class UpdateMyDetailsRequest implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.lang.String givenName = null;
	private boolean __patchedGivenName = false;
	private java.lang.String familyName = null;
	private boolean __patchedFamilyName = false;
	private java.lang.String currentPassword = null;
	private boolean __patchedCurrentPassword = false;
	private java.lang.String newPassword = null;
	private boolean __patchedNewPassword = false;
	private java.lang.String confirmPassword = null;
	private boolean __patchedConfirmPassword = false;
	
	/**
	 */
	public UpdateMyDetailsRequest givenName(java.lang.String givenName) {
		setGivenName(givenName);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("givenName")
	public java.lang.String getGivenName() {
		return this.givenName;
	}
	public void setGivenName(java.lang.String givenName) {
		this.givenName = givenName;
		this.__patchedGivenName = true;
	}
	public boolean patchedGivenName() {
		return this.__patchedGivenName;
	}
	
	/**
	 */
	public UpdateMyDetailsRequest familyName(java.lang.String familyName) {
		setFamilyName(familyName);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("familyName")
	public java.lang.String getFamilyName() {
		return this.familyName;
	}
	public void setFamilyName(java.lang.String familyName) {
		this.familyName = familyName;
		this.__patchedFamilyName = true;
	}
	public boolean patchedFamilyName() {
		return this.__patchedFamilyName;
	}
	
	/**
	 */
	public UpdateMyDetailsRequest currentPassword(java.lang.String currentPassword) {
		setCurrentPassword(currentPassword);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("currentPassword")
	public java.lang.String getCurrentPassword() {
		return this.currentPassword;
	}
	public void setCurrentPassword(java.lang.String currentPassword) {
		this.currentPassword = currentPassword;
		this.__patchedCurrentPassword = true;
	}
	public boolean patchedCurrentPassword() {
		return this.__patchedCurrentPassword;
	}
	
	/**
	 */
	public UpdateMyDetailsRequest newPassword(java.lang.String newPassword) {
		setNewPassword(newPassword);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("newPassword")
	@javax.validation.constraints.Size(min=6, message="Your password must be at least {min} characters long.")
	public java.lang.String getNewPassword() {
		return this.newPassword;
	}
	public void setNewPassword(java.lang.String newPassword) {
		this.newPassword = newPassword;
		this.__patchedNewPassword = true;
	}
	public boolean patchedNewPassword() {
		return this.__patchedNewPassword;
	}
	
	/**
	 */
	public UpdateMyDetailsRequest confirmPassword(java.lang.String confirmPassword) {
		setConfirmPassword(confirmPassword);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("confirmPassword")
	public java.lang.String getConfirmPassword() {
		return this.confirmPassword;
	}
	public void setConfirmPassword(java.lang.String confirmPassword) {
		this.confirmPassword = confirmPassword;
		this.__patchedConfirmPassword = true;
	}
	public boolean patchedConfirmPassword() {
		return this.__patchedConfirmPassword;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		UpdateMyDetailsRequest updateMyDetailsRequest = (UpdateMyDetailsRequest) o;
		return java.util.Objects.equals(this.givenName, updateMyDetailsRequest.givenName) &&
				java.util.Objects.equals(this.familyName, updateMyDetailsRequest.familyName) &&
				java.util.Objects.equals(this.currentPassword, updateMyDetailsRequest.currentPassword) &&
				java.util.Objects.equals(this.newPassword, updateMyDetailsRequest.newPassword) &&
				java.util.Objects.equals(this.confirmPassword, updateMyDetailsRequest.confirmPassword);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.givenName, this.familyName, this.currentPassword, this.newPassword, this.confirmPassword);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class UpdateMyDetailsRequest {\n");
		
		sb.append("    givenName: ").append(toIndentedString(this.givenName)).append("\n");
		sb.append("    familyName: ").append(toIndentedString(this.familyName)).append("\n");
		sb.append("    currentPassword: ").append(toIndentedString(this.currentPassword)).append("\n");
		sb.append("    newPassword: ").append(toIndentedString(this.newPassword)).append("\n");
		sb.append("    confirmPassword: ").append(toIndentedString(this.confirmPassword)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
